/* Fx.c generated by valac 0.42.7, the Vala compiler
 * generated from Fx.vala, do not modify */

/*
 * Copyright (C) 2015 Rico Tzschichholz
 * Copyright (c) 2017-2019 José Amuedo (https://github.com/spheras)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
     * Utility functions to calculate progress of transitions.
     * Ported from Plank: https://github.com/ricotz/plank/blob/master/lib/Drawing/Easing.vala
     */


#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

typedef enum  {
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_CUSTOM = 0,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LINEAR,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUAD,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUAD,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUAD,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CUBIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CUBIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CUBIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUART,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUART,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUART,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUINT,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUINT,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUINT,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_SINE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_SINE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_SINE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_EXPO,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_EXPO,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_EXPO,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CIRC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CIRC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CIRC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_ELASTIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_ELASTIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_ELASTIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BACK,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BACK,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BACK,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BOUNCE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BOUNCE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BOUNCE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LAST
} DesktopFolderUtilFxAnimationMode;


#define DESKTOP_FOLDER_UTIL_FX_TYPE_ANIMATION_MODE (desktop_folder_util_fx_animation_mode_get_type ())
typedef gdouble (*DesktopFolderUtilFxEasingFunc) (gdouble t, gdouble d);

#define DESKTOP_FOLDER_UTIL_FX_TYPE_ANIMATION_MODE_MAPPING (desktop_folder_util_fx_animation_mode_mapping_get_type ())
typedef struct _DesktopFolderUtilFxAnimationModeMapping DesktopFolderUtilFxAnimationModeMapping;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _DesktopFolderUtilFxAnimationModeMapping {
	DesktopFolderUtilFxAnimationMode mode;
	DesktopFolderUtilFxEasingFunc func;
	gchar* name;
};



GType desktop_folder_util_fx_animation_mode_get_type (void) G_GNUC_CONST;
GType desktop_folder_util_fx_animation_mode_mapping_get_type (void) G_GNUC_CONST;
DesktopFolderUtilFxAnimationModeMapping* desktop_folder_util_fx_animation_mode_mapping_dup (const DesktopFolderUtilFxAnimationModeMapping* self);
void desktop_folder_util_fx_animation_mode_mapping_free (DesktopFolderUtilFxAnimationModeMapping* self);
void desktop_folder_util_fx_animation_mode_mapping_copy (const DesktopFolderUtilFxAnimationModeMapping* self,
                                                         DesktopFolderUtilFxAnimationModeMapping* dest);
void desktop_folder_util_fx_animation_mode_mapping_destroy (DesktopFolderUtilFxAnimationModeMapping* self);
gdouble desktop_folder_util_fx_linear (gdouble t,
                                       gdouble d);
static gdouble _desktop_folder_util_fx_linear_desktop_folder_util_fx_easing_func (gdouble t,
                                                                           gdouble d);
gdouble desktop_folder_util_fx_ease_in_quad (gdouble t,
                                             gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_quad_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                 gdouble d);
gdouble desktop_folder_util_fx_ease_out_quad (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_quad_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
gdouble desktop_folder_util_fx_ease_in_out_quad (gdouble t,
                                                 gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_quad_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                     gdouble d);
gdouble desktop_folder_util_fx_ease_in_cubic (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_cubic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
gdouble desktop_folder_util_fx_ease_out_cubic (gdouble t,
                                               gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_cubic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                   gdouble d);
gdouble desktop_folder_util_fx_ease_in_out_cubic (gdouble t,
                                                  gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_cubic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                      gdouble d);
gdouble desktop_folder_util_fx_ease_in_quart (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_quart_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
gdouble desktop_folder_util_fx_ease_out_quart (gdouble t,
                                               gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_quart_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                   gdouble d);
gdouble desktop_folder_util_fx_ease_in_out_quart (gdouble t,
                                                  gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_quart_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                      gdouble d);
gdouble desktop_folder_util_fx_ease_in_quint (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_quint_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
gdouble desktop_folder_util_fx_ease_out_quint (gdouble t,
                                               gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_quint_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                   gdouble d);
gdouble desktop_folder_util_fx_ease_in_out_quint (gdouble t,
                                                  gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_quint_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                      gdouble d);
gdouble desktop_folder_util_fx_ease_in_sine (gdouble t,
                                             gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_sine_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                 gdouble d);
gdouble desktop_folder_util_fx_ease_out_sine (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_sine_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
gdouble desktop_folder_util_fx_ease_in_out_sine (gdouble t,
                                                 gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_sine_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                     gdouble d);
gdouble desktop_folder_util_fx_ease_in_expo (gdouble t,
                                             gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_expo_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                 gdouble d);
gdouble desktop_folder_util_fx_ease_out_expo (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_expo_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
gdouble desktop_folder_util_fx_ease_in_out_expo (gdouble t,
                                                 gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_expo_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                     gdouble d);
gdouble desktop_folder_util_fx_ease_in_circ (gdouble t,
                                             gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_circ_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                 gdouble d);
gdouble desktop_folder_util_fx_ease_out_circ (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_circ_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
gdouble desktop_folder_util_fx_ease_in_out_circ (gdouble t,
                                                 gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_circ_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                     gdouble d);
gdouble desktop_folder_util_fx_ease_in_elastic (gdouble t,
                                                gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_elastic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                    gdouble d);
gdouble desktop_folder_util_fx_ease_out_elastic (gdouble t,
                                                 gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_elastic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                     gdouble d);
gdouble desktop_folder_util_fx_ease_in_out_elastic (gdouble t,
                                                    gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_elastic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                        gdouble d);
gdouble desktop_folder_util_fx_ease_in_back (gdouble t,
                                             gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_back_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                 gdouble d);
gdouble desktop_folder_util_fx_ease_out_back (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_back_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
gdouble desktop_folder_util_fx_ease_in_out_back (gdouble t,
                                                 gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_back_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                     gdouble d);
gdouble desktop_folder_util_fx_ease_in_bounce (gdouble t,
                                               gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_bounce_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                   gdouble d);
gdouble desktop_folder_util_fx_ease_out_bounce (gdouble t,
                                                gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_bounce_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                    gdouble d);
gdouble desktop_folder_util_fx_ease_in_out_bounce (gdouble t,
                                                   gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_bounce_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                       gdouble d);
DesktopFolderUtilFxEasingFunc desktop_folder_util_fx_easing_func_for_mode (DesktopFolderUtilFxAnimationMode mode);
const gchar* desktop_folder_util_fx_easing_name_for_mode (DesktopFolderUtilFxAnimationMode mode);
gdouble desktop_folder_util_fx_easing_for_mode (DesktopFolderUtilFxAnimationMode mode,
                                                gdouble t,
                                                gdouble d);
gdouble desktop_folder_util_fx_ease_out_bounce_internal (gdouble t,
                                                         gdouble d);
gdouble desktop_folder_util_fx_ease_in_bounce_internal (gdouble t,
                                                        gdouble d);

const DesktopFolderUtilFxAnimationModeMapping DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODES[33] = {{DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_CUSTOM, NULL, "custom"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LINEAR, _desktop_folder_util_fx_linear_desktop_folder_util_fx_easing_func, "linear"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUAD, _desktop_folder_util_fx_ease_in_quad_desktop_folder_util_fx_easing_func, "easeInQuad"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUAD, _desktop_folder_util_fx_ease_out_quad_desktop_folder_util_fx_easing_func, "easeOutQuad"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUAD, _desktop_folder_util_fx_ease_in_out_quad_desktop_folder_util_fx_easing_func, "easeInOutQuad"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CUBIC, _desktop_folder_util_fx_ease_in_cubic_desktop_folder_util_fx_easing_func, "easeInCubic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CUBIC, _desktop_folder_util_fx_ease_out_cubic_desktop_folder_util_fx_easing_func, "easeOutCubic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CUBIC, _desktop_folder_util_fx_ease_in_out_cubic_desktop_folder_util_fx_easing_func, "easeInOutCubic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUART, _desktop_folder_util_fx_ease_in_quart_desktop_folder_util_fx_easing_func, "easeInQuart"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUART, _desktop_folder_util_fx_ease_out_quart_desktop_folder_util_fx_easing_func, "easeOutQuart"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUART, _desktop_folder_util_fx_ease_in_out_quart_desktop_folder_util_fx_easing_func, "easeInOutQuart"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUINT, _desktop_folder_util_fx_ease_in_quint_desktop_folder_util_fx_easing_func, "easeInQuint"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUINT, _desktop_folder_util_fx_ease_out_quint_desktop_folder_util_fx_easing_func, "easeOutQuint"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUINT, _desktop_folder_util_fx_ease_in_out_quint_desktop_folder_util_fx_easing_func, "easeInOutQuint"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_SINE, _desktop_folder_util_fx_ease_in_sine_desktop_folder_util_fx_easing_func, "easeInSine"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_SINE, _desktop_folder_util_fx_ease_out_sine_desktop_folder_util_fx_easing_func, "easeOutSine"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_SINE, _desktop_folder_util_fx_ease_in_out_sine_desktop_folder_util_fx_easing_func, "easeInOutSine"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_EXPO, _desktop_folder_util_fx_ease_in_expo_desktop_folder_util_fx_easing_func, "easeInExpo"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_EXPO, _desktop_folder_util_fx_ease_out_expo_desktop_folder_util_fx_easing_func, "easeOutExpo"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_EXPO, _desktop_folder_util_fx_ease_in_out_expo_desktop_folder_util_fx_easing_func, "easeInOutExpo"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CIRC, _desktop_folder_util_fx_ease_in_circ_desktop_folder_util_fx_easing_func, "easeInCirc"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CIRC, _desktop_folder_util_fx_ease_out_circ_desktop_folder_util_fx_easing_func, "easeOutCirc"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CIRC, _desktop_folder_util_fx_ease_in_out_circ_desktop_folder_util_fx_easing_func, "easeInOutCirc"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_ELASTIC, _desktop_folder_util_fx_ease_in_elastic_desktop_folder_util_fx_easing_func, "easeInElastic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_ELASTIC, _desktop_folder_util_fx_ease_out_elastic_desktop_folder_util_fx_easing_func, "easeOutElastic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_ELASTIC, _desktop_folder_util_fx_ease_in_out_elastic_desktop_folder_util_fx_easing_func, "easeInOutElastic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BACK, _desktop_folder_util_fx_ease_in_back_desktop_folder_util_fx_easing_func, "easeInBack"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BACK, _desktop_folder_util_fx_ease_out_back_desktop_folder_util_fx_easing_func, "easeOutBack"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BACK, _desktop_folder_util_fx_ease_in_out_back_desktop_folder_util_fx_easing_func, "easeInOutBack"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BOUNCE, _desktop_folder_util_fx_ease_in_bounce_desktop_folder_util_fx_easing_func, "easeInBounce"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BOUNCE, _desktop_folder_util_fx_ease_out_bounce_desktop_folder_util_fx_easing_func, "easeOutBounce"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BOUNCE, _desktop_folder_util_fx_ease_in_out_bounce_desktop_folder_util_fx_easing_func, "easeInOutBounce"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LAST, NULL, "sentinel"}};

/**
     * The available animation modes
     */
GType
desktop_folder_util_fx_animation_mode_get_type (void)
{
	static volatile gsize desktop_folder_util_fx_animation_mode_type_id__volatile = 0;
	if (g_once_init_enter (&desktop_folder_util_fx_animation_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_CUSTOM, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_CUSTOM", "custom"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LINEAR, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LINEAR", "linear"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUAD, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUAD", "ease-in-quad"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUAD, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUAD", "ease-out-quad"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUAD, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUAD", "ease-in-out-quad"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CUBIC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CUBIC", "ease-in-cubic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CUBIC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CUBIC", "ease-out-cubic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CUBIC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CUBIC", "ease-in-out-cubic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUART, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUART", "ease-in-quart"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUART, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUART", "ease-out-quart"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUART, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUART", "ease-in-out-quart"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUINT, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUINT", "ease-in-quint"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUINT, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUINT", "ease-out-quint"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUINT, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUINT", "ease-in-out-quint"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_SINE, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_SINE", "ease-in-sine"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_SINE, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_SINE", "ease-out-sine"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_SINE, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_SINE", "ease-in-out-sine"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_EXPO, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_EXPO", "ease-in-expo"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_EXPO, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_EXPO", "ease-out-expo"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_EXPO, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_EXPO", "ease-in-out-expo"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CIRC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CIRC", "ease-in-circ"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CIRC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CIRC", "ease-out-circ"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CIRC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CIRC", "ease-in-out-circ"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_ELASTIC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_ELASTIC", "ease-in-elastic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_ELASTIC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_ELASTIC", "ease-out-elastic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_ELASTIC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_ELASTIC", "ease-in-out-elastic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BACK, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BACK", "ease-in-back"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BACK, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BACK", "ease-out-back"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BACK, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BACK", "ease-in-out-back"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BOUNCE, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BOUNCE", "ease-in-bounce"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BOUNCE, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BOUNCE", "ease-out-bounce"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BOUNCE, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BOUNCE", "ease-in-out-bounce"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LAST, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LAST", "last"}, {0, NULL, NULL}};
		GType desktop_folder_util_fx_animation_mode_type_id;
		desktop_folder_util_fx_animation_mode_type_id = g_enum_register_static ("DesktopFolderUtilFxAnimationMode", values);
		g_once_init_leave (&desktop_folder_util_fx_animation_mode_type_id__volatile, desktop_folder_util_fx_animation_mode_type_id);
	}
	return desktop_folder_util_fx_animation_mode_type_id__volatile;
}


void
desktop_folder_util_fx_animation_mode_mapping_copy (const DesktopFolderUtilFxAnimationModeMapping* self,
                                                    DesktopFolderUtilFxAnimationModeMapping* dest)
{
	DesktopFolderUtilFxAnimationMode _tmp0_;
	DesktopFolderUtilFxEasingFunc _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 180 "../src/utils/animation/Fx.vala"
	_tmp0_ = (*self).mode;
#line 180 "../src/utils/animation/Fx.vala"
	(*dest).mode = _tmp0_;
#line 180 "../src/utils/animation/Fx.vala"
	_tmp1_ = (*self).func;
#line 180 "../src/utils/animation/Fx.vala"
	(*dest).func = _tmp1_;
#line 180 "../src/utils/animation/Fx.vala"
	_tmp2_ = (*self).name;
#line 180 "../src/utils/animation/Fx.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 180 "../src/utils/animation/Fx.vala"
	_g_free0 ((*dest).name);
#line 180 "../src/utils/animation/Fx.vala"
	(*dest).name = _tmp3_;
#line 275 "Fx.c"
}


void
desktop_folder_util_fx_animation_mode_mapping_destroy (DesktopFolderUtilFxAnimationModeMapping* self)
{
#line 183 "../src/utils/animation/Fx.vala"
	_g_free0 ((*self).name);
#line 284 "Fx.c"
}


DesktopFolderUtilFxAnimationModeMapping*
desktop_folder_util_fx_animation_mode_mapping_dup (const DesktopFolderUtilFxAnimationModeMapping* self)
{
	DesktopFolderUtilFxAnimationModeMapping* dup;
#line 180 "../src/utils/animation/Fx.vala"
	dup = g_new0 (DesktopFolderUtilFxAnimationModeMapping, 1);
#line 180 "../src/utils/animation/Fx.vala"
	desktop_folder_util_fx_animation_mode_mapping_copy (self, dup);
#line 180 "../src/utils/animation/Fx.vala"
	return dup;
#line 298 "Fx.c"
}


void
desktop_folder_util_fx_animation_mode_mapping_free (DesktopFolderUtilFxAnimationModeMapping* self)
{
#line 180 "../src/utils/animation/Fx.vala"
	desktop_folder_util_fx_animation_mode_mapping_destroy (self);
#line 180 "../src/utils/animation/Fx.vala"
	g_free (self);
#line 309 "Fx.c"
}


GType
desktop_folder_util_fx_animation_mode_mapping_get_type (void)
{
	static volatile gsize desktop_folder_util_fx_animation_mode_mapping_type_id__volatile = 0;
	if (g_once_init_enter (&desktop_folder_util_fx_animation_mode_mapping_type_id__volatile)) {
		GType desktop_folder_util_fx_animation_mode_mapping_type_id;
		desktop_folder_util_fx_animation_mode_mapping_type_id = g_boxed_type_register_static ("DesktopFolderUtilFxAnimationModeMapping", (GBoxedCopyFunc) desktop_folder_util_fx_animation_mode_mapping_dup, (GBoxedFreeFunc) desktop_folder_util_fx_animation_mode_mapping_free);
		g_once_init_leave (&desktop_folder_util_fx_animation_mode_mapping_type_id__volatile, desktop_folder_util_fx_animation_mode_mapping_type_id);
	}
	return desktop_folder_util_fx_animation_mode_mapping_type_id__volatile;
}


static gdouble
_desktop_folder_util_fx_linear_desktop_folder_util_fx_easing_func (gdouble t,
                                                                   gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_linear (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 334 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_quad_desktop_folder_util_fx_easing_func (gdouble t,
                                                                         gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_quad (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 346 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_out_quad_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_quad (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 358 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_out_quad_desktop_folder_util_fx_easing_func (gdouble t,
                                                                             gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_quad (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 370 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_cubic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_cubic (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 382 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_out_cubic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                           gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_cubic (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 394 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_out_cubic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                              gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_cubic (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 406 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_quart_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_quart (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 418 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_out_quart_desktop_folder_util_fx_easing_func (gdouble t,
                                                                           gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_quart (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 430 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_out_quart_desktop_folder_util_fx_easing_func (gdouble t,
                                                                              gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_quart (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 442 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_quint_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_quint (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 454 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_out_quint_desktop_folder_util_fx_easing_func (gdouble t,
                                                                           gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_quint (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 466 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_out_quint_desktop_folder_util_fx_easing_func (gdouble t,
                                                                              gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_quint (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 478 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_sine_desktop_folder_util_fx_easing_func (gdouble t,
                                                                         gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_sine (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 490 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_out_sine_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_sine (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 502 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_out_sine_desktop_folder_util_fx_easing_func (gdouble t,
                                                                             gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_sine (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 514 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_expo_desktop_folder_util_fx_easing_func (gdouble t,
                                                                         gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_expo (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 526 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_out_expo_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_expo (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 538 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_out_expo_desktop_folder_util_fx_easing_func (gdouble t,
                                                                             gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_expo (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 550 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_circ_desktop_folder_util_fx_easing_func (gdouble t,
                                                                         gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_circ (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 562 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_out_circ_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_circ (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 574 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_out_circ_desktop_folder_util_fx_easing_func (gdouble t,
                                                                             gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_circ (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 586 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_elastic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                            gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_elastic (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 598 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_out_elastic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                             gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_elastic (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 610 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_out_elastic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_elastic (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 622 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_back_desktop_folder_util_fx_easing_func (gdouble t,
                                                                         gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_back (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 634 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_out_back_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_back (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 646 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_out_back_desktop_folder_util_fx_easing_func (gdouble t,
                                                                             gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_back (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 658 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_bounce_desktop_folder_util_fx_easing_func (gdouble t,
                                                                           gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_bounce (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 670 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_out_bounce_desktop_folder_util_fx_easing_func (gdouble t,
                                                                            gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_bounce (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 682 "Fx.c"
}


static gdouble
_desktop_folder_util_fx_ease_in_out_bounce_desktop_folder_util_fx_easing_func (gdouble t,
                                                                               gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_bounce (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 694 "Fx.c"
}


DesktopFolderUtilFxEasingFunc
desktop_folder_util_fx_easing_func_for_mode (DesktopFolderUtilFxAnimationMode mode)
{
	DesktopFolderUtilFxEasingFunc result = NULL;
	DesktopFolderUtilFxAnimationModeMapping* animation = NULL;
	DesktopFolderUtilFxAnimationMode _tmp0_;
	DesktopFolderUtilFxEasingFunc _tmp1_;
	DesktopFolderUtilFxEasingFunc _tmp2_;
#line 225 "../src/utils/animation/Fx.vala"
	animation = &DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODES[mode];
#line 227 "../src/utils/animation/Fx.vala"
	_tmp0_ = (*animation).mode;
#line 227 "../src/utils/animation/Fx.vala"
	_vala_assert (_tmp0_ == mode, "animation.mode == mode");
#line 228 "../src/utils/animation/Fx.vala"
	_tmp1_ = (*animation).func;
#line 228 "../src/utils/animation/Fx.vala"
	_vala_assert (_tmp1_ != NULL, "animation.func != null");
#line 230 "../src/utils/animation/Fx.vala"
	_tmp2_ = (*animation).func;
#line 230 "../src/utils/animation/Fx.vala"
	result = _tmp2_;
#line 230 "../src/utils/animation/Fx.vala"
	return result;
#line 722 "Fx.c"
}


const gchar*
desktop_folder_util_fx_easing_name_for_mode (DesktopFolderUtilFxAnimationMode mode)
{
	const gchar* result = NULL;
	DesktopFolderUtilFxAnimationModeMapping* animation = NULL;
	DesktopFolderUtilFxAnimationMode _tmp0_;
	DesktopFolderUtilFxEasingFunc _tmp1_;
	const gchar* _tmp2_;
#line 234 "../src/utils/animation/Fx.vala"
	animation = &DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODES[mode];
#line 236 "../src/utils/animation/Fx.vala"
	_tmp0_ = (*animation).mode;
#line 236 "../src/utils/animation/Fx.vala"
	_vala_assert (_tmp0_ == mode, "animation.mode == mode");
#line 237 "../src/utils/animation/Fx.vala"
	_tmp1_ = (*animation).func;
#line 237 "../src/utils/animation/Fx.vala"
	_vala_assert (_tmp1_ != NULL, "animation.func != null");
#line 239 "../src/utils/animation/Fx.vala"
	_tmp2_ = (*animation).name;
#line 239 "../src/utils/animation/Fx.vala"
	result = _tmp2_;
#line 239 "../src/utils/animation/Fx.vala"
	return result;
#line 750 "Fx.c"
}


/**
     * Calculate an interpolated value for selected animation-mode, and given
     * elapsed time and total duration.
     *
     * @param mode animation-mode to be used
     * @param t elapsed time
     * @param d total duration
     * @return the interpolated value, between -1.0 and 2.0
     */
gdouble
desktop_folder_util_fx_easing_for_mode (DesktopFolderUtilFxAnimationMode mode,
                                        gdouble t,
                                        gdouble d)
{
	gdouble result = 0.0;
	DesktopFolderUtilFxAnimationModeMapping* animation = NULL;
	DesktopFolderUtilFxAnimationMode _tmp0_;
	DesktopFolderUtilFxEasingFunc _tmp1_;
	DesktopFolderUtilFxEasingFunc _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
#line 251 "../src/utils/animation/Fx.vala"
	_vala_return_val_if_fail ((t >= 0.0) && (d > 0.0), "t >= 0.0 && d > 0.0", 0.0);
#line 251 "../src/utils/animation/Fx.vala"
	_vala_return_val_if_fail (t <= d, "t <= d", 0.0);
#line 256 "../src/utils/animation/Fx.vala"
	animation = &DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODES[mode];
#line 258 "../src/utils/animation/Fx.vala"
	_tmp0_ = (*animation).mode;
#line 258 "../src/utils/animation/Fx.vala"
	_vala_assert (_tmp0_ == mode, "animation.mode == mode");
#line 259 "../src/utils/animation/Fx.vala"
	_tmp1_ = (*animation).func;
#line 259 "../src/utils/animation/Fx.vala"
	_vala_assert (_tmp1_ != NULL, "animation.func != null");
#line 261 "../src/utils/animation/Fx.vala"
	_tmp2_ = (*animation).func;
#line 261 "../src/utils/animation/Fx.vala"
	result = _tmp2_ (t, d);
#line 261 "../src/utils/animation/Fx.vala"
	_tmp3_ = result;
#line 261 "../src/utils/animation/Fx.vala"
	_tmp4_ = result;
#line 261 "../src/utils/animation/Fx.vala"
	_vala_warn_if_fail ((_tmp3_ >= (-1.0)) && (_tmp4_ <= 2.0), "result >= -1.0 && result <= 2.0");
#line 261 "../src/utils/animation/Fx.vala"
	return result;
#line 803 "Fx.c"
}


gdouble
desktop_folder_util_fx_linear (gdouble t,
                               gdouble d)
{
	gdouble result = 0.0;
#line 265 "../src/utils/animation/Fx.vala"
	result = t / d;
#line 265 "../src/utils/animation/Fx.vala"
	return result;
#line 816 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_quad (gdouble t,
                                     gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
#line 269 "../src/utils/animation/Fx.vala"
	p = t / d;
#line 271 "../src/utils/animation/Fx.vala"
	result = p * p;
#line 271 "../src/utils/animation/Fx.vala"
	return result;
#line 832 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_out_quad (gdouble t,
                                      gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
#line 275 "../src/utils/animation/Fx.vala"
	p = t / d;
#line 277 "../src/utils/animation/Fx.vala"
	result = ((-1.0) * p) * (p - 2);
#line 277 "../src/utils/animation/Fx.vala"
	return result;
#line 848 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_out_quad (gdouble t,
                                         gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
	gdouble _tmp0_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
#line 281 "../src/utils/animation/Fx.vala"
	p = t / (d / 2);
#line 283 "../src/utils/animation/Fx.vala"
	_tmp0_ = p;
#line 283 "../src/utils/animation/Fx.vala"
	if (_tmp0_ < ((gdouble) 1)) {
#line 868 "Fx.c"
		gdouble _tmp1_;
		gdouble _tmp2_;
#line 284 "../src/utils/animation/Fx.vala"
		_tmp1_ = p;
#line 284 "../src/utils/animation/Fx.vala"
		_tmp2_ = p;
#line 284 "../src/utils/animation/Fx.vala"
		result = (0.5 * _tmp1_) * _tmp2_;
#line 284 "../src/utils/animation/Fx.vala"
		return result;
#line 879 "Fx.c"
	}
#line 286 "../src/utils/animation/Fx.vala"
	_tmp3_ = p;
#line 286 "../src/utils/animation/Fx.vala"
	p = _tmp3_ - 1;
#line 288 "../src/utils/animation/Fx.vala"
	_tmp4_ = p;
#line 288 "../src/utils/animation/Fx.vala"
	_tmp5_ = p;
#line 288 "../src/utils/animation/Fx.vala"
	result = (-0.5) * ((_tmp4_ * (_tmp5_ - 2)) - 1);
#line 288 "../src/utils/animation/Fx.vala"
	return result;
#line 893 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_cubic (gdouble t,
                                      gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
#line 292 "../src/utils/animation/Fx.vala"
	p = t / d;
#line 294 "../src/utils/animation/Fx.vala"
	result = (p * p) * p;
#line 294 "../src/utils/animation/Fx.vala"
	return result;
#line 909 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_out_cubic (gdouble t,
                                       gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
#line 298 "../src/utils/animation/Fx.vala"
	p = (t / d) - 1;
#line 300 "../src/utils/animation/Fx.vala"
	result = ((p * p) * p) + 1;
#line 300 "../src/utils/animation/Fx.vala"
	return result;
#line 925 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_out_cubic (gdouble t,
                                          gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
	gdouble _tmp0_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
#line 304 "../src/utils/animation/Fx.vala"
	p = t / (d / 2);
#line 306 "../src/utils/animation/Fx.vala"
	_tmp0_ = p;
#line 306 "../src/utils/animation/Fx.vala"
	if (_tmp0_ < ((gdouble) 1)) {
#line 946 "Fx.c"
		gdouble _tmp1_;
		gdouble _tmp2_;
		gdouble _tmp3_;
#line 307 "../src/utils/animation/Fx.vala"
		_tmp1_ = p;
#line 307 "../src/utils/animation/Fx.vala"
		_tmp2_ = p;
#line 307 "../src/utils/animation/Fx.vala"
		_tmp3_ = p;
#line 307 "../src/utils/animation/Fx.vala"
		result = ((0.5 * _tmp1_) * _tmp2_) * _tmp3_;
#line 307 "../src/utils/animation/Fx.vala"
		return result;
#line 960 "Fx.c"
	}
#line 309 "../src/utils/animation/Fx.vala"
	_tmp4_ = p;
#line 309 "../src/utils/animation/Fx.vala"
	p = _tmp4_ - 2;
#line 311 "../src/utils/animation/Fx.vala"
	_tmp5_ = p;
#line 311 "../src/utils/animation/Fx.vala"
	_tmp6_ = p;
#line 311 "../src/utils/animation/Fx.vala"
	_tmp7_ = p;
#line 311 "../src/utils/animation/Fx.vala"
	result = 0.5 * (((_tmp5_ * _tmp6_) * _tmp7_) + 2);
#line 311 "../src/utils/animation/Fx.vala"
	return result;
#line 976 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_quart (gdouble t,
                                      gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
#line 315 "../src/utils/animation/Fx.vala"
	p = t / d;
#line 317 "../src/utils/animation/Fx.vala"
	result = ((p * p) * p) * p;
#line 317 "../src/utils/animation/Fx.vala"
	return result;
#line 992 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_out_quart (gdouble t,
                                       gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
#line 321 "../src/utils/animation/Fx.vala"
	p = (t / d) - 1;
#line 323 "../src/utils/animation/Fx.vala"
	result = (-1.0) * ((((p * p) * p) * p) - 1);
#line 323 "../src/utils/animation/Fx.vala"
	return result;
#line 1008 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_out_quart (gdouble t,
                                          gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
	gdouble _tmp0_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
#line 327 "../src/utils/animation/Fx.vala"
	p = t / (d / 2);
#line 329 "../src/utils/animation/Fx.vala"
	_tmp0_ = p;
#line 329 "../src/utils/animation/Fx.vala"
	if (_tmp0_ < ((gdouble) 1)) {
#line 1030 "Fx.c"
		gdouble _tmp1_;
		gdouble _tmp2_;
		gdouble _tmp3_;
		gdouble _tmp4_;
#line 330 "../src/utils/animation/Fx.vala"
		_tmp1_ = p;
#line 330 "../src/utils/animation/Fx.vala"
		_tmp2_ = p;
#line 330 "../src/utils/animation/Fx.vala"
		_tmp3_ = p;
#line 330 "../src/utils/animation/Fx.vala"
		_tmp4_ = p;
#line 330 "../src/utils/animation/Fx.vala"
		result = (((0.5 * _tmp1_) * _tmp2_) * _tmp3_) * _tmp4_;
#line 330 "../src/utils/animation/Fx.vala"
		return result;
#line 1047 "Fx.c"
	}
#line 332 "../src/utils/animation/Fx.vala"
	_tmp5_ = p;
#line 332 "../src/utils/animation/Fx.vala"
	p = _tmp5_ - 2;
#line 334 "../src/utils/animation/Fx.vala"
	_tmp6_ = p;
#line 334 "../src/utils/animation/Fx.vala"
	_tmp7_ = p;
#line 334 "../src/utils/animation/Fx.vala"
	_tmp8_ = p;
#line 334 "../src/utils/animation/Fx.vala"
	_tmp9_ = p;
#line 334 "../src/utils/animation/Fx.vala"
	result = (-0.5) * ((((_tmp6_ * _tmp7_) * _tmp8_) * _tmp9_) - 2);
#line 334 "../src/utils/animation/Fx.vala"
	return result;
#line 1065 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_quint (gdouble t,
                                      gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
#line 338 "../src/utils/animation/Fx.vala"
	p = t / d;
#line 340 "../src/utils/animation/Fx.vala"
	result = (((p * p) * p) * p) * p;
#line 340 "../src/utils/animation/Fx.vala"
	return result;
#line 1081 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_out_quint (gdouble t,
                                       gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
#line 344 "../src/utils/animation/Fx.vala"
	p = (t / d) - 1;
#line 346 "../src/utils/animation/Fx.vala"
	result = ((((p * p) * p) * p) * p) + 1;
#line 346 "../src/utils/animation/Fx.vala"
	return result;
#line 1097 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_out_quint (gdouble t,
                                          gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
	gdouble _tmp0_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
#line 350 "../src/utils/animation/Fx.vala"
	p = t / (d / 2);
#line 352 "../src/utils/animation/Fx.vala"
	_tmp0_ = p;
#line 352 "../src/utils/animation/Fx.vala"
	if (_tmp0_ < ((gdouble) 1)) {
#line 1120 "Fx.c"
		gdouble _tmp1_;
		gdouble _tmp2_;
		gdouble _tmp3_;
		gdouble _tmp4_;
		gdouble _tmp5_;
#line 353 "../src/utils/animation/Fx.vala"
		_tmp1_ = p;
#line 353 "../src/utils/animation/Fx.vala"
		_tmp2_ = p;
#line 353 "../src/utils/animation/Fx.vala"
		_tmp3_ = p;
#line 353 "../src/utils/animation/Fx.vala"
		_tmp4_ = p;
#line 353 "../src/utils/animation/Fx.vala"
		_tmp5_ = p;
#line 353 "../src/utils/animation/Fx.vala"
		result = ((((0.5 * _tmp1_) * _tmp2_) * _tmp3_) * _tmp4_) * _tmp5_;
#line 353 "../src/utils/animation/Fx.vala"
		return result;
#line 1140 "Fx.c"
	}
#line 355 "../src/utils/animation/Fx.vala"
	_tmp6_ = p;
#line 355 "../src/utils/animation/Fx.vala"
	p = _tmp6_ - 2;
#line 357 "../src/utils/animation/Fx.vala"
	_tmp7_ = p;
#line 357 "../src/utils/animation/Fx.vala"
	_tmp8_ = p;
#line 357 "../src/utils/animation/Fx.vala"
	_tmp9_ = p;
#line 357 "../src/utils/animation/Fx.vala"
	_tmp10_ = p;
#line 357 "../src/utils/animation/Fx.vala"
	_tmp11_ = p;
#line 357 "../src/utils/animation/Fx.vala"
	result = 0.5 * (((((_tmp7_ * _tmp8_) * _tmp9_) * _tmp10_) * _tmp11_) + 2);
#line 357 "../src/utils/animation/Fx.vala"
	return result;
#line 1160 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_sine (gdouble t,
                                     gdouble d)
{
	gdouble result = 0.0;
#line 361 "../src/utils/animation/Fx.vala"
	result = ((-1.0) * cos ((t / d) * G_PI_2)) + 1.0;
#line 361 "../src/utils/animation/Fx.vala"
	return result;
#line 1173 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_out_sine (gdouble t,
                                      gdouble d)
{
	gdouble result = 0.0;
#line 365 "../src/utils/animation/Fx.vala"
	result = sin ((t / d) * G_PI_2);
#line 365 "../src/utils/animation/Fx.vala"
	return result;
#line 1186 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_out_sine (gdouble t,
                                         gdouble d)
{
	gdouble result = 0.0;
#line 369 "../src/utils/animation/Fx.vala"
	result = (-0.5) * (cos ((G_PI * t) / d) - 1);
#line 369 "../src/utils/animation/Fx.vala"
	return result;
#line 1199 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_expo (gdouble t,
                                     gdouble d)
{
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
#line 373 "../src/utils/animation/Fx.vala"
	if (t == ((gdouble) 0)) {
#line 373 "../src/utils/animation/Fx.vala"
		_tmp0_ = 0.0;
#line 1213 "Fx.c"
	} else {
#line 373 "../src/utils/animation/Fx.vala"
		_tmp0_ = pow ((gdouble) 2, 10 * ((t / d) - 1));
#line 1217 "Fx.c"
	}
#line 373 "../src/utils/animation/Fx.vala"
	result = _tmp0_;
#line 373 "../src/utils/animation/Fx.vala"
	return result;
#line 1223 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_out_expo (gdouble t,
                                      gdouble d)
{
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
#line 377 "../src/utils/animation/Fx.vala"
	if (t == d) {
#line 377 "../src/utils/animation/Fx.vala"
		_tmp0_ = 1.0;
#line 1237 "Fx.c"
	} else {
#line 377 "../src/utils/animation/Fx.vala"
		_tmp0_ = (-pow ((gdouble) 2, (-10 * t) / d)) + 1;
#line 1241 "Fx.c"
	}
#line 377 "../src/utils/animation/Fx.vala"
	result = _tmp0_;
#line 377 "../src/utils/animation/Fx.vala"
	return result;
#line 1247 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_out_expo (gdouble t,
                                         gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
	gdouble _tmp0_;
	gdouble _tmp2_;
	gdouble _tmp3_;
#line 383 "../src/utils/animation/Fx.vala"
	if (t == ((gdouble) 0)) {
#line 384 "../src/utils/animation/Fx.vala"
		result = 0.0;
#line 384 "../src/utils/animation/Fx.vala"
		return result;
#line 1266 "Fx.c"
	}
#line 386 "../src/utils/animation/Fx.vala"
	if (t == d) {
#line 387 "../src/utils/animation/Fx.vala"
		result = 1.0;
#line 387 "../src/utils/animation/Fx.vala"
		return result;
#line 1274 "Fx.c"
	}
#line 389 "../src/utils/animation/Fx.vala"
	p = t / (d / 2);
#line 391 "../src/utils/animation/Fx.vala"
	_tmp0_ = p;
#line 391 "../src/utils/animation/Fx.vala"
	if (_tmp0_ < ((gdouble) 1)) {
#line 1282 "Fx.c"
		gdouble _tmp1_;
#line 392 "../src/utils/animation/Fx.vala"
		_tmp1_ = p;
#line 392 "../src/utils/animation/Fx.vala"
		result = 0.5 * pow ((gdouble) 2, 10 * (_tmp1_ - 1));
#line 392 "../src/utils/animation/Fx.vala"
		return result;
#line 1290 "Fx.c"
	}
#line 394 "../src/utils/animation/Fx.vala"
	_tmp2_ = p;
#line 394 "../src/utils/animation/Fx.vala"
	p = _tmp2_ - 1;
#line 396 "../src/utils/animation/Fx.vala"
	_tmp3_ = p;
#line 396 "../src/utils/animation/Fx.vala"
	result = 0.5 * ((-pow ((gdouble) 2, -10 * _tmp3_)) + 2);
#line 396 "../src/utils/animation/Fx.vala"
	return result;
#line 1302 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_circ (gdouble t,
                                     gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
#line 400 "../src/utils/animation/Fx.vala"
	p = t / d;
#line 402 "../src/utils/animation/Fx.vala"
	result = (-1.0) * (sqrt (1 - (p * p)) - 1);
#line 402 "../src/utils/animation/Fx.vala"
	return result;
#line 1318 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_out_circ (gdouble t,
                                      gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
#line 406 "../src/utils/animation/Fx.vala"
	p = (t / d) - 1;
#line 408 "../src/utils/animation/Fx.vala"
	result = sqrt (1 - (p * p));
#line 408 "../src/utils/animation/Fx.vala"
	return result;
#line 1334 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_out_circ (gdouble t,
                                         gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
	gdouble _tmp0_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
#line 412 "../src/utils/animation/Fx.vala"
	p = t / (d / 2);
#line 414 "../src/utils/animation/Fx.vala"
	_tmp0_ = p;
#line 414 "../src/utils/animation/Fx.vala"
	if (_tmp0_ < ((gdouble) 1)) {
#line 1354 "Fx.c"
		gdouble _tmp1_;
		gdouble _tmp2_;
#line 415 "../src/utils/animation/Fx.vala"
		_tmp1_ = p;
#line 415 "../src/utils/animation/Fx.vala"
		_tmp2_ = p;
#line 415 "../src/utils/animation/Fx.vala"
		result = (-0.5) * (sqrt (1 - (_tmp1_ * _tmp2_)) - 1);
#line 415 "../src/utils/animation/Fx.vala"
		return result;
#line 1365 "Fx.c"
	}
#line 417 "../src/utils/animation/Fx.vala"
	_tmp3_ = p;
#line 417 "../src/utils/animation/Fx.vala"
	p = _tmp3_ - 2;
#line 419 "../src/utils/animation/Fx.vala"
	_tmp4_ = p;
#line 419 "../src/utils/animation/Fx.vala"
	_tmp5_ = p;
#line 419 "../src/utils/animation/Fx.vala"
	result = 0.5 * (sqrt (1 - (_tmp4_ * _tmp5_)) + 1);
#line 419 "../src/utils/animation/Fx.vala"
	return result;
#line 1379 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_elastic (gdouble t,
                                        gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
	gdouble s = 0.0;
	gdouble _tmp0_;
	gdouble q = 0.0;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
#line 423 "../src/utils/animation/Fx.vala"
	p = d * 0.3;
#line 424 "../src/utils/animation/Fx.vala"
	_tmp0_ = p;
#line 424 "../src/utils/animation/Fx.vala"
	s = _tmp0_ / 4;
#line 425 "../src/utils/animation/Fx.vala"
	q = t / d;
#line 427 "../src/utils/animation/Fx.vala"
	_tmp1_ = q;
#line 427 "../src/utils/animation/Fx.vala"
	if (_tmp1_ == ((gdouble) 1)) {
#line 428 "../src/utils/animation/Fx.vala"
		result = 1.0;
#line 428 "../src/utils/animation/Fx.vala"
		return result;
#line 1414 "Fx.c"
	}
#line 430 "../src/utils/animation/Fx.vala"
	_tmp2_ = q;
#line 430 "../src/utils/animation/Fx.vala"
	q = _tmp2_ - 1;
#line 432 "../src/utils/animation/Fx.vala"
	_tmp3_ = q;
#line 432 "../src/utils/animation/Fx.vala"
	_tmp4_ = q;
#line 432 "../src/utils/animation/Fx.vala"
	_tmp5_ = s;
#line 432 "../src/utils/animation/Fx.vala"
	_tmp6_ = p;
#line 432 "../src/utils/animation/Fx.vala"
	result = -(pow ((gdouble) 2, 10 * _tmp3_) * sin ((((_tmp4_ * d) - _tmp5_) * (2 * G_PI)) / _tmp6_));
#line 432 "../src/utils/animation/Fx.vala"
	return result;
#line 1432 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_out_elastic (gdouble t,
                                         gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
	gdouble s = 0.0;
	gdouble _tmp0_;
	gdouble q = 0.0;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
#line 436 "../src/utils/animation/Fx.vala"
	p = d * 0.3;
#line 437 "../src/utils/animation/Fx.vala"
	_tmp0_ = p;
#line 437 "../src/utils/animation/Fx.vala"
	s = _tmp0_ / 4;
#line 438 "../src/utils/animation/Fx.vala"
	q = t / d;
#line 440 "../src/utils/animation/Fx.vala"
	_tmp1_ = q;
#line 440 "../src/utils/animation/Fx.vala"
	if (_tmp1_ == ((gdouble) 1)) {
#line 441 "../src/utils/animation/Fx.vala"
		result = 1.0;
#line 441 "../src/utils/animation/Fx.vala"
		return result;
#line 1466 "Fx.c"
	}
#line 443 "../src/utils/animation/Fx.vala"
	_tmp2_ = q;
#line 443 "../src/utils/animation/Fx.vala"
	_tmp3_ = q;
#line 443 "../src/utils/animation/Fx.vala"
	_tmp4_ = s;
#line 443 "../src/utils/animation/Fx.vala"
	_tmp5_ = p;
#line 443 "../src/utils/animation/Fx.vala"
	result = (pow ((gdouble) 2, -10 * _tmp2_) * sin ((((_tmp3_ * d) - _tmp4_) * (2 * G_PI)) / _tmp5_)) + 1.0;
#line 443 "../src/utils/animation/Fx.vala"
	return result;
#line 1480 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_out_elastic (gdouble t,
                                            gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
	gdouble s = 0.0;
	gdouble _tmp0_;
	gdouble q = 0.0;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 447 "../src/utils/animation/Fx.vala"
	p = d * (0.3 * 1.5);
#line 448 "../src/utils/animation/Fx.vala"
	_tmp0_ = p;
#line 448 "../src/utils/animation/Fx.vala"
	s = _tmp0_ / 4;
#line 449 "../src/utils/animation/Fx.vala"
	q = t / (d / 2);
#line 451 "../src/utils/animation/Fx.vala"
	_tmp1_ = q;
#line 451 "../src/utils/animation/Fx.vala"
	if (_tmp1_ == ((gdouble) 2)) {
#line 452 "../src/utils/animation/Fx.vala"
		result = 1.0;
#line 452 "../src/utils/animation/Fx.vala"
		return result;
#line 1511 "Fx.c"
	}
#line 454 "../src/utils/animation/Fx.vala"
	_tmp2_ = q;
#line 454 "../src/utils/animation/Fx.vala"
	if (_tmp2_ < ((gdouble) 1)) {
#line 1517 "Fx.c"
		gdouble _tmp3_;
		gdouble _tmp4_;
		gdouble _tmp5_;
		gdouble _tmp6_;
		gdouble _tmp7_;
#line 455 "../src/utils/animation/Fx.vala"
		_tmp3_ = q;
#line 455 "../src/utils/animation/Fx.vala"
		q = _tmp3_ - 1;
#line 457 "../src/utils/animation/Fx.vala"
		_tmp4_ = q;
#line 457 "../src/utils/animation/Fx.vala"
		_tmp5_ = q;
#line 457 "../src/utils/animation/Fx.vala"
		_tmp6_ = s;
#line 457 "../src/utils/animation/Fx.vala"
		_tmp7_ = p;
#line 457 "../src/utils/animation/Fx.vala"
		result = (-0.5) * (pow ((gdouble) 2, 10 * _tmp4_) * sin ((((_tmp5_ * d) - _tmp6_) * (2 * G_PI)) / _tmp7_));
#line 457 "../src/utils/animation/Fx.vala"
		return result;
#line 1539 "Fx.c"
	} else {
		gdouble _tmp8_;
		gdouble _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_;
#line 459 "../src/utils/animation/Fx.vala"
		_tmp8_ = q;
#line 459 "../src/utils/animation/Fx.vala"
		q = _tmp8_ - 1;
#line 461 "../src/utils/animation/Fx.vala"
		_tmp9_ = q;
#line 461 "../src/utils/animation/Fx.vala"
		_tmp10_ = q;
#line 461 "../src/utils/animation/Fx.vala"
		_tmp11_ = s;
#line 461 "../src/utils/animation/Fx.vala"
		_tmp12_ = p;
#line 461 "../src/utils/animation/Fx.vala"
		result = ((pow ((gdouble) 2, -10 * _tmp9_) * sin ((((_tmp10_ * d) - _tmp11_) * (2 * G_PI)) / _tmp12_)) * 0.5) + 1.0;
#line 461 "../src/utils/animation/Fx.vala"
		return result;
#line 1562 "Fx.c"
	}
}


gdouble
desktop_folder_util_fx_ease_in_back (gdouble t,
                                     gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
#line 468 "../src/utils/animation/Fx.vala"
	p = t / d;
#line 470 "../src/utils/animation/Fx.vala"
	result = (p * p) * (((1.70158 + 1) * p) - 1.70158);
#line 470 "../src/utils/animation/Fx.vala"
	return result;
#line 1579 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_out_back (gdouble t,
                                      gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
#line 474 "../src/utils/animation/Fx.vala"
	p = (t / d) - 1;
#line 476 "../src/utils/animation/Fx.vala"
	result = ((p * p) * (((1.70158 + 1) * p) + 1.70158)) + 1;
#line 476 "../src/utils/animation/Fx.vala"
	return result;
#line 1595 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_out_back (gdouble t,
                                         gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
	gdouble s = 0.0;
	gdouble _tmp0_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
#line 480 "../src/utils/animation/Fx.vala"
	p = t / (d / 2);
#line 481 "../src/utils/animation/Fx.vala"
	s = 1.70158 * 1.525;
#line 483 "../src/utils/animation/Fx.vala"
	_tmp0_ = p;
#line 483 "../src/utils/animation/Fx.vala"
	if (_tmp0_ < ((gdouble) 1)) {
#line 1621 "Fx.c"
		gdouble _tmp1_;
		gdouble _tmp2_;
		gdouble _tmp3_;
		gdouble _tmp4_;
		gdouble _tmp5_;
#line 484 "../src/utils/animation/Fx.vala"
		_tmp1_ = p;
#line 484 "../src/utils/animation/Fx.vala"
		_tmp2_ = p;
#line 484 "../src/utils/animation/Fx.vala"
		_tmp3_ = s;
#line 484 "../src/utils/animation/Fx.vala"
		_tmp4_ = p;
#line 484 "../src/utils/animation/Fx.vala"
		_tmp5_ = s;
#line 484 "../src/utils/animation/Fx.vala"
		result = 0.5 * ((_tmp1_ * _tmp2_) * (((_tmp3_ + 1) * _tmp4_) - _tmp5_));
#line 484 "../src/utils/animation/Fx.vala"
		return result;
#line 1641 "Fx.c"
	}
#line 486 "../src/utils/animation/Fx.vala"
	_tmp6_ = p;
#line 486 "../src/utils/animation/Fx.vala"
	p = _tmp6_ - 2;
#line 488 "../src/utils/animation/Fx.vala"
	_tmp7_ = p;
#line 488 "../src/utils/animation/Fx.vala"
	_tmp8_ = p;
#line 488 "../src/utils/animation/Fx.vala"
	_tmp9_ = s;
#line 488 "../src/utils/animation/Fx.vala"
	_tmp10_ = p;
#line 488 "../src/utils/animation/Fx.vala"
	_tmp11_ = s;
#line 488 "../src/utils/animation/Fx.vala"
	result = 0.5 * (((_tmp7_ * _tmp8_) * (((_tmp9_ + 1) * _tmp10_) + _tmp11_)) + 2);
#line 488 "../src/utils/animation/Fx.vala"
	return result;
#line 1661 "Fx.c"
}


inline gdouble
desktop_folder_util_fx_ease_out_bounce_internal (gdouble t,
                                                 gdouble d)
{
	gdouble result = 0.0;
	gdouble p = 0.0;
	gdouble _tmp0_;
#line 492 "../src/utils/animation/Fx.vala"
	p = t / d;
#line 494 "../src/utils/animation/Fx.vala"
	_tmp0_ = p;
#line 494 "../src/utils/animation/Fx.vala"
	if (_tmp0_ < (1 / 2.75)) {
#line 1678 "Fx.c"
		gdouble _tmp1_;
		gdouble _tmp2_;
#line 495 "../src/utils/animation/Fx.vala"
		_tmp1_ = p;
#line 495 "../src/utils/animation/Fx.vala"
		_tmp2_ = p;
#line 495 "../src/utils/animation/Fx.vala"
		result = (7.5625 * _tmp1_) * _tmp2_;
#line 495 "../src/utils/animation/Fx.vala"
		return result;
#line 1689 "Fx.c"
	} else {
		gdouble _tmp3_;
#line 496 "../src/utils/animation/Fx.vala"
		_tmp3_ = p;
#line 496 "../src/utils/animation/Fx.vala"
		if (_tmp3_ < (2 / 2.75)) {
#line 1696 "Fx.c"
			gdouble _tmp4_;
			gdouble _tmp5_;
			gdouble _tmp6_;
#line 497 "../src/utils/animation/Fx.vala"
			_tmp4_ = p;
#line 497 "../src/utils/animation/Fx.vala"
			p = _tmp4_ - (1.5 / 2.75);
#line 499 "../src/utils/animation/Fx.vala"
			_tmp5_ = p;
#line 499 "../src/utils/animation/Fx.vala"
			_tmp6_ = p;
#line 499 "../src/utils/animation/Fx.vala"
			result = ((7.5625 * _tmp5_) * _tmp6_) + 0.75;
#line 499 "../src/utils/animation/Fx.vala"
			return result;
#line 1712 "Fx.c"
		} else {
			gdouble _tmp7_;
#line 500 "../src/utils/animation/Fx.vala"
			_tmp7_ = p;
#line 500 "../src/utils/animation/Fx.vala"
			if (_tmp7_ < (2.5 / 2.75)) {
#line 1719 "Fx.c"
				gdouble _tmp8_;
				gdouble _tmp9_;
				gdouble _tmp10_;
#line 501 "../src/utils/animation/Fx.vala"
				_tmp8_ = p;
#line 501 "../src/utils/animation/Fx.vala"
				p = _tmp8_ - (2.25 / 2.75);
#line 503 "../src/utils/animation/Fx.vala"
				_tmp9_ = p;
#line 503 "../src/utils/animation/Fx.vala"
				_tmp10_ = p;
#line 503 "../src/utils/animation/Fx.vala"
				result = ((7.5625 * _tmp9_) * _tmp10_) + 0.9375;
#line 503 "../src/utils/animation/Fx.vala"
				return result;
#line 1735 "Fx.c"
			} else {
				gdouble _tmp11_;
				gdouble _tmp12_;
				gdouble _tmp13_;
#line 505 "../src/utils/animation/Fx.vala"
				_tmp11_ = p;
#line 505 "../src/utils/animation/Fx.vala"
				p = _tmp11_ - (2.625 / 2.75);
#line 507 "../src/utils/animation/Fx.vala"
				_tmp12_ = p;
#line 507 "../src/utils/animation/Fx.vala"
				_tmp13_ = p;
#line 507 "../src/utils/animation/Fx.vala"
				result = ((7.5625 * _tmp12_) * _tmp13_) + 0.984375;
#line 507 "../src/utils/animation/Fx.vala"
				return result;
#line 1752 "Fx.c"
			}
		}
	}
}


inline gdouble
desktop_folder_util_fx_ease_in_bounce_internal (gdouble t,
                                                gdouble d)
{
	gdouble result = 0.0;
#line 512 "../src/utils/animation/Fx.vala"
	result = 1.0 - desktop_folder_util_fx_ease_out_bounce_internal (d - t, d);
#line 512 "../src/utils/animation/Fx.vala"
	return result;
#line 1768 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_bounce (gdouble t,
                                       gdouble d)
{
	gdouble result = 0.0;
#line 516 "../src/utils/animation/Fx.vala"
	result = desktop_folder_util_fx_ease_in_bounce_internal (t, d);
#line 516 "../src/utils/animation/Fx.vala"
	return result;
#line 1781 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_out_bounce (gdouble t,
                                        gdouble d)
{
	gdouble result = 0.0;
#line 520 "../src/utils/animation/Fx.vala"
	result = desktop_folder_util_fx_ease_out_bounce_internal (t, d);
#line 520 "../src/utils/animation/Fx.vala"
	return result;
#line 1794 "Fx.c"
}


gdouble
desktop_folder_util_fx_ease_in_out_bounce (gdouble t,
                                           gdouble d)
{
	gdouble result = 0.0;
#line 524 "../src/utils/animation/Fx.vala"
	if (t < (d / 2)) {
#line 525 "../src/utils/animation/Fx.vala"
		result = desktop_folder_util_fx_ease_in_bounce_internal (t * 2, d) * 0.5;
#line 525 "../src/utils/animation/Fx.vala"
		return result;
#line 1809 "Fx.c"
	} else {
#line 527 "../src/utils/animation/Fx.vala"
		result = (desktop_folder_util_fx_ease_out_bounce_internal ((t * 2) - d, d) * 0.5) + (1.0 * 0.5);
#line 527 "../src/utils/animation/Fx.vala"
		return result;
#line 1815 "Fx.c"
	}
}



