/* DragNDrop.c generated by valac 0.42.7, the Vala compiler
 * generated from DragNDrop.vala, do not modify */

/*
 * Copyright (c) 2017-2019 José Amuedo (https://github.com/spheras)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>

typedef enum  {
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_STRING,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_XDND_DIRECT_SAVE0,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_NETSCAPE_URL
} DesktopFolderDragnDropTargetType;


#define DESKTOP_FOLDER_DRAGN_DROP_TYPE_TARGET_TYPE (desktop_folder_dragn_drop_target_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block4Data Block4Data;

#define DESKTOP_FOLDER_TYPE_PROGRESS_DIALOG (desktop_folder_progress_dialog_get_type ())
#define DESKTOP_FOLDER_PROGRESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_PROGRESS_DIALOG, DesktopFolderProgressDialog))
#define DESKTOP_FOLDER_PROGRESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_PROGRESS_DIALOG, DesktopFolderProgressDialogClass))
#define DESKTOP_FOLDER_IS_PROGRESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_PROGRESS_DIALOG))
#define DESKTOP_FOLDER_IS_PROGRESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_PROGRESS_DIALOG))
#define DESKTOP_FOLDER_PROGRESS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_PROGRESS_DIALOG, DesktopFolderProgressDialogClass))

typedef struct _DesktopFolderProgressDialog DesktopFolderProgressDialog;
typedef struct _DesktopFolderProgressDialogClass DesktopFolderProgressDialogClass;
typedef struct _Block5Data Block5Data;
typedef void (*DesktopFolderUtilFileOperationAction) (GFile* file, gpointer user_data);
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))

struct _Block4Data {
	int _ref_count_;
	GFile* f;
};

struct _Block5Data {
	int _ref_count_;
	Block4Data * _data4_;
	GFile* final_target;
	DesktopFolderProgressDialog* pd;
	GCancellable* cancellable;
};



GType desktop_folder_dragn_drop_target_type_get_type (void) G_GNUC_CONST;
#define DESKTOP_FOLDER_DRAGN_DROP_file_drag_actions ((GDK_ACTION_COPY | GDK_ACTION_MOVE) | GDK_ACTION_LINK)
gboolean desktop_folder_dragn_drop_util_is_folder (GFile* file);
gboolean desktop_folder_dragn_drop_util_is_trashed (GFile* file);
gchar* desktop_folder_dragn_drop_util_get_display_target_uri (GFile* file);
gboolean desktop_folder_dragn_drop_util_same_filesystem (GFile* file_a,
                                                         GFile* file_b);
GdkDragAction desktop_folder_dragn_drop_util_file_accepts_drop (GFile* file,
                                                                GList* file_list,
                                                                GdkDragContext* context,
                                                                GdkDragAction* suggested_action_return);
GList* desktop_folder_dragn_drop_util_list_new_from_string (const gchar* str);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
void desktop_folder_dragn_drop_util_copy_move (GList* files,
                                               GFile* target_dir,
                                               GdkDragAction action,
                                               GtkWidget* parent_view,
                                               GCallback done_callback,
                                               GtkWidget* done_callback_data);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
const gchar* gdk_drag_action_to_string (GdkDragAction self);
GType desktop_folder_progress_dialog_get_type (void) G_GNUC_CONST;
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
#define DESKTOP_FOLDER_LANG_DRAGNDROP_FILE_OPERATIONS _ ("File Operations")
DesktopFolderProgressDialog* desktop_folder_progress_dialog_new (const gchar* title,
                                                                 GtkWindow* parent);
DesktopFolderProgressDialog* desktop_folder_progress_dialog_construct (GType object_type,
                                                                       const gchar* title,
                                                                       GtkWindow* parent);
GCancellable* desktop_folder_progress_dialog_start (DesktopFolderProgressDialog* self);
static gint _________lambda17_ (Block5Data* _data5_);
gboolean desktop_folder_util_copy_recursive (GFile* src,
                                             GFile* dest,
                                             GFileCopyFlags flags,
                                             GCancellable* cancellable,
                                             DesktopFolderUtilFileOperationAction listener,
                                             gpointer listener_target,
                                             GError** error);
static void ___lambda18_ (Block5Data* _data5_,
                   GFile* file);
#define DESKTOP_FOLDER_LANG_DRAGNDROP_COPYING _ ("Copying")
void desktop_folder_progress_dialog_show_action (DesktopFolderProgressDialog* self,
                                                 const gchar* action);
static void ____lambda18__desktop_folder_util_file_operation_action (GFile* file,
                                                              gpointer self);
void desktop_folder_progress_dialog_stop (DesktopFolderProgressDialog* self);
static gpointer __________lambda17__gthread_func (gpointer self);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

const GtkTargetEntry DESKTOP_FOLDER_DRAGN_DROP_drag_targets[2] = {{"text/plain", (guint) GTK_TARGET_SAME_APP, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_STRING}, {"text/uri-list", (guint) GTK_TARGET_SAME_APP, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST}};
const GtkTargetEntry DESKTOP_FOLDER_DRAGN_DROP_drop_targets[4] = {{"text/uri-list", (guint) GTK_TARGET_SAME_APP, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST}, {"text/uri-list", (guint) GTK_TARGET_OTHER_APP, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST}, {"XdndDirectSave0", (guint) GTK_TARGET_OTHER_APP, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_XDND_DIRECT_SAVE0}, {"_NETSCAPE_URL", (guint) GTK_TARGET_OTHER_APP, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_NETSCAPE_URL}};

GType
desktop_folder_dragn_drop_target_type_get_type (void)
{
	static volatile gsize desktop_folder_dragn_drop_target_type_type_id__volatile = 0;
	if (g_once_init_enter (&desktop_folder_dragn_drop_target_type_type_id__volatile)) {
		static const GEnumValue values[] = {{DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_STRING, "DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_STRING", "string"}, {DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST, "DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST", "text-uri-list"}, {DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_XDND_DIRECT_SAVE0, "DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_XDND_DIRECT_SAVE0", "xdnd-direct-save0"}, {DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_NETSCAPE_URL, "DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_NETSCAPE_URL", "netscape-url"}, {0, NULL, NULL}};
		GType desktop_folder_dragn_drop_target_type_type_id;
		desktop_folder_dragn_drop_target_type_type_id = g_enum_register_static ("DesktopFolderDragnDropTargetType", values);
		g_once_init_leave (&desktop_folder_dragn_drop_target_type_type_id__volatile, desktop_folder_dragn_drop_target_type_type_id);
	}
	return desktop_folder_dragn_drop_target_type_type_id__volatile;
}


/**
         * @name is_folder
         * @description check if a certain file is a folder or not
         * @param File file the file to check
         * @return boole true->yes, the file is a folder
         */
gboolean
desktop_folder_dragn_drop_util_is_folder (GFile* file)
{
	gboolean result = FALSE;
	GFileType type = 0;
#line 58 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 60 "../src/utils/dragndrop/DragNDrop.vala"
	type = g_file_query_file_type (file, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 61 "../src/utils/dragndrop/DragNDrop.vala"
	result = type == G_FILE_TYPE_DIRECTORY;
#line 61 "../src/utils/dragndrop/DragNDrop.vala"
	return result;
#line 169 "DragNDrop.c"
}


/**
         * @name is_tarshed
         * @description check whether the file is in trash or not
         * @return bool true->yes, it is in trash
         */
gboolean
desktop_folder_dragn_drop_util_is_trashed (GFile* file)
{
	gboolean result = FALSE;
#line 69 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 71 "../src/utils/dragndrop/DragNDrop.vala"
	result = g_file_has_uri_scheme (file, "trash");
#line 71 "../src/utils/dragndrop/DragNDrop.vala"
	return result;
#line 188 "DragNDrop.c"
}


gchar*
desktop_folder_dragn_drop_util_get_display_target_uri (GFile* file)
{
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 74 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 199 "DragNDrop.c"
	{
		GFileInfo* fileInfo = NULL;
		GFileInfo* _tmp0_;
		gchar* uri = NULL;
		gchar* _tmp1_;
		const gchar* _tmp2_;
#line 77 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_TARGET_URI, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 77 "../src/utils/dragndrop/DragNDrop.vala"
		fileInfo = _tmp0_;
#line 77 "../src/utils/dragndrop/DragNDrop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 212 "DragNDrop.c"
			goto __catch7_g_error;
		}
#line 78 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp1_ = g_file_info_get_attribute_as_string (fileInfo, G_FILE_ATTRIBUTE_STANDARD_TARGET_URI);
#line 78 "../src/utils/dragndrop/DragNDrop.vala"
		uri = _tmp1_;
#line 80 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp2_ = uri;
#line 80 "../src/utils/dragndrop/DragNDrop.vala"
		if (_tmp2_ == NULL) {
#line 223 "DragNDrop.c"
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
#line 81 "../src/utils/dragndrop/DragNDrop.vala"
			_tmp3_ = g_file_get_uri (file);
#line 81 "../src/utils/dragndrop/DragNDrop.vala"
			_tmp4_ = _tmp3_;
#line 81 "../src/utils/dragndrop/DragNDrop.vala"
			_tmp5_ = g_strconcat ("", _tmp4_, NULL);
#line 81 "../src/utils/dragndrop/DragNDrop.vala"
			_g_free0 (uri);
#line 81 "../src/utils/dragndrop/DragNDrop.vala"
			uri = _tmp5_;
#line 81 "../src/utils/dragndrop/DragNDrop.vala"
			_g_free0 (_tmp4_);
#line 239 "DragNDrop.c"
		}
#line 84 "../src/utils/dragndrop/DragNDrop.vala"
		result = uri;
#line 84 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (fileInfo);
#line 84 "../src/utils/dragndrop/DragNDrop.vala"
		return result;
#line 247 "DragNDrop.c"
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* _error_ = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 76 "../src/utils/dragndrop/DragNDrop.vala"
		_error_ = _inner_error0_;
#line 76 "../src/utils/dragndrop/DragNDrop.vala"
		_inner_error0_ = NULL;
#line 86 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp6_ = stderr;
#line 86 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp7_ = _error_;
#line 86 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp8_ = _tmp7_->message;
#line 86 "../src/utils/dragndrop/DragNDrop.vala"
		fprintf (_tmp6_, "Error: %s\n", _tmp8_);
#line 87 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp9_ = g_strdup ("");
#line 87 "../src/utils/dragndrop/DragNDrop.vala"
		result = _tmp9_;
#line 87 "../src/utils/dragndrop/DragNDrop.vala"
		_g_error_free0 (_error_);
#line 87 "../src/utils/dragndrop/DragNDrop.vala"
		return result;
#line 277 "DragNDrop.c"
	}
	__finally7:
#line 76 "../src/utils/dragndrop/DragNDrop.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 76 "../src/utils/dragndrop/DragNDrop.vala"
	g_clear_error (&_inner_error0_);
#line 76 "../src/utils/dragndrop/DragNDrop.vala"
	return NULL;
#line 286 "DragNDrop.c"
}


gboolean
desktop_folder_dragn_drop_util_same_filesystem (GFile* file_a,
                                                GFile* file_b)
{
	gboolean result = FALSE;
	gchar* filesystem_id_a = NULL;
	gchar* filesystem_id_b = NULL;
	GFileInfo* ainfo = NULL;
	GFileInfo* binfo = NULL;
	gboolean _tmp10_ = FALSE;
	GFileInfo* _tmp11_;
	GFileInfo* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	GFileInfo* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	GError* _inner_error0_ = NULL;
#line 91 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_val_if_fail (file_a != NULL, FALSE);
#line 91 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_val_if_fail (file_b != NULL, FALSE);
#line 96 "../src/utils/dragndrop/DragNDrop.vala"
	ainfo = NULL;
#line 97 "../src/utils/dragndrop/DragNDrop.vala"
	binfo = NULL;
#line 318 "DragNDrop.c"
	{
		GFileInfo* _tmp0_ = NULL;
		GFileInfo* _tmp1_;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_ = NULL;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 99 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp1_ = g_file_query_filesystem_info (file_a, "*", NULL, &_inner_error0_);
#line 99 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp0_ = _tmp1_;
#line 99 "../src/utils/dragndrop/DragNDrop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 332 "DragNDrop.c"
			goto __catch8_g_error;
		}
#line 99 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp2_ = _tmp0_;
#line 99 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp0_ = NULL;
#line 99 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (ainfo);
#line 99 "../src/utils/dragndrop/DragNDrop.vala"
		ainfo = _tmp2_;
#line 100 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp4_ = g_file_query_filesystem_info (file_b, "*", NULL, &_inner_error0_);
#line 100 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp3_ = _tmp4_;
#line 100 "../src/utils/dragndrop/DragNDrop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "../src/utils/dragndrop/DragNDrop.vala"
			_g_object_unref0 (_tmp0_);
#line 351 "DragNDrop.c"
			goto __catch8_g_error;
		}
#line 100 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp5_ = _tmp3_;
#line 100 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp3_ = NULL;
#line 100 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (binfo);
#line 100 "../src/utils/dragndrop/DragNDrop.vala"
		binfo = _tmp5_;
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (_tmp3_);
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (_tmp0_);
#line 366 "DragNDrop.c"
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* e = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		e = _inner_error0_;
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		_inner_error0_ = NULL;
#line 102 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp6_ = stderr;
#line 102 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp7_ = e;
#line 102 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp8_ = _tmp7_->message;
#line 102 "../src/utils/dragndrop/DragNDrop.vala"
		fprintf (_tmp6_, "Error: %s\n", _tmp8_);
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		_g_error_free0 (e);
#line 389 "DragNDrop.c"
	}
	__finally8:
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 394 "DragNDrop.c"
		gboolean _tmp9_ = FALSE;
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (binfo);
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (ainfo);
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		_g_free0 (filesystem_id_b);
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		_g_free0 (filesystem_id_a);
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		g_clear_error (&_inner_error0_);
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		return _tmp9_;
#line 410 "DragNDrop.c"
	}
#line 106 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp11_ = ainfo;
#line 106 "../src/utils/dragndrop/DragNDrop.vala"
	if (_tmp11_ == NULL) {
#line 106 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp10_ = TRUE;
#line 418 "DragNDrop.c"
	} else {
		GFileInfo* _tmp12_;
#line 106 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp12_ = binfo;
#line 106 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp10_ = _tmp12_ == NULL;
#line 425 "DragNDrop.c"
	}
#line 106 "../src/utils/dragndrop/DragNDrop.vala"
	if (_tmp10_) {
#line 107 "../src/utils/dragndrop/DragNDrop.vala"
		result = FALSE;
#line 107 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (binfo);
#line 107 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (ainfo);
#line 107 "../src/utils/dragndrop/DragNDrop.vala"
		_g_free0 (filesystem_id_b);
#line 107 "../src/utils/dragndrop/DragNDrop.vala"
		_g_free0 (filesystem_id_a);
#line 107 "../src/utils/dragndrop/DragNDrop.vala"
		return result;
#line 441 "DragNDrop.c"
	}
#line 110 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp13_ = ainfo;
#line 110 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp14_ = g_file_info_get_attribute_string (_tmp13_, G_FILE_ATTRIBUTE_ID_FILESYSTEM);
#line 110 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 110 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (filesystem_id_a);
#line 110 "../src/utils/dragndrop/DragNDrop.vala"
	filesystem_id_a = _tmp15_;
#line 112 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp16_ = binfo;
#line 112 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp17_ = g_file_info_get_attribute_string (_tmp16_, G_FILE_ATTRIBUTE_ID_FILESYSTEM);
#line 112 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp18_ = g_strdup (_tmp17_);
#line 112 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (filesystem_id_b);
#line 112 "../src/utils/dragndrop/DragNDrop.vala"
	filesystem_id_b = _tmp18_;
#line 115 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp19_ = filesystem_id_a;
#line 115 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp20_ = filesystem_id_b;
#line 115 "../src/utils/dragndrop/DragNDrop.vala"
	result = g_strcmp0 (_tmp19_, _tmp20_) == 0;
#line 115 "../src/utils/dragndrop/DragNDrop.vala"
	_g_object_unref0 (binfo);
#line 115 "../src/utils/dragndrop/DragNDrop.vala"
	_g_object_unref0 (ainfo);
#line 115 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (filesystem_id_b);
#line 115 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (filesystem_id_a);
#line 115 "../src/utils/dragndrop/DragNDrop.vala"
	return result;
#line 479 "DragNDrop.c"
}


/**
         * gof_file_accepts_drop (imported from thunar):
         * @file                    : a #GOFFile instance.
         * @file_list               : the list of #GFile<!---->s that will be droppped.
         * @context                 : the current #GdkDragContext, which is used for the drop.
         * @suggested_action_return : return location for the suggested #GdkDragAction or %NULL.
         *
         * Checks whether @file can accept @path_list for the given @context and
         * returns the #GdkDragAction<!---->s that can be used or 0 if no actions
         * apply.
         *
         * If any #GdkDragAction<!---->s apply and @suggested_action_return is not
         * %NULL, the suggested #GdkDragAction for this drop will be stored to the
         * location pointed to by @suggested_action_return.
         *
         * Return value: the #GdkDragAction<!---->s supported for the drop or
         *               0 if no drop is possible.
         **/
static gpointer
_g_object_ref0 (gpointer self)
{
#line 170 "../src/utils/dragndrop/DragNDrop.vala"
	return self ? g_object_ref (self) : NULL;
#line 506 "DragNDrop.c"
}


GdkDragAction
desktop_folder_dragn_drop_util_file_accepts_drop (GFile* file,
                                                  GList* file_list,
                                                  GdkDragContext* context,
                                                  GdkDragAction* suggested_action_return)
{
	GdkDragAction _vala_suggested_action_return = 0U;
	GdkDragAction result = 0U;
	GdkDragAction suggested_action = 0U;
	GdkDragAction actions = 0U;
	GFile* ofile = NULL;
	GFile* parent_file = NULL;
	guint n = 0U;
	gint i = 0;
	gchar* scheme = NULL;
	gchar* _tmp51_;
	const gchar* _tmp52_;
	GdkDragAction _tmp55_;
	GdkDragAction _tmp56_;
	GError* _inner_error0_ = NULL;
#line 137 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_val_if_fail (file != NULL, 0U);
#line 137 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_val_if_fail (context != NULL, 0U);
#line 147 "../src/utils/dragndrop/DragNDrop.vala"
	i = 0;
#line 148 "../src/utils/dragndrop/DragNDrop.vala"
	_vala_suggested_action_return = GDK_ACTION_PRIVATE;
#line 151 "../src/utils/dragndrop/DragNDrop.vala"
	if (file_list == NULL) {
#line 152 "../src/utils/dragndrop/DragNDrop.vala"
		result = 0;
#line 152 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (parent_file);
#line 152 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (ofile);
#line 152 "../src/utils/dragndrop/DragNDrop.vala"
		if (suggested_action_return) {
#line 152 "../src/utils/dragndrop/DragNDrop.vala"
			*suggested_action_return = _vala_suggested_action_return;
#line 550 "DragNDrop.c"
		}
#line 152 "../src/utils/dragndrop/DragNDrop.vala"
		return result;
#line 554 "DragNDrop.c"
	}
#line 155 "../src/utils/dragndrop/DragNDrop.vala"
	suggested_action = gdk_drag_context_get_suggested_action (context);
#line 158 "../src/utils/dragndrop/DragNDrop.vala"
	if (desktop_folder_dragn_drop_util_is_folder (file)) {
#line 560 "DragNDrop.c"
		gboolean _tmp23_ = FALSE;
		GdkDragAction _tmp24_;
#line 161 "../src/utils/dragndrop/DragNDrop.vala"
		actions = gdk_drag_context_get_actions (context) & (((GDK_ACTION_COPY | GDK_ACTION_MOVE) | GDK_ACTION_LINK) | GDK_ACTION_ASK);
#line 565 "DragNDrop.c"
		{
			gboolean _tmp0_ = FALSE;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
			n = (guint) 0;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
			i = 0;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
			_tmp0_ = TRUE;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
			while (TRUE) {
#line 576 "DragNDrop.c"
				gboolean _tmp3_ = FALSE;
				gint _tmp4_;
				GFile* fi = NULL;
				gint _tmp6_;
				GList* _tmp7_;
				gconstpointer _tmp8_;
				GFile* _tmp9_;
				GFile* _tmp10_;
				GFile* _tmp11_;
				GFile* _tmp12_;
				GFile* _tmp13_;
				gchar* scheme = NULL;
				GFile* _tmp17_;
				gchar* _tmp18_;
				const gchar* _tmp19_;
				gboolean _tmp21_ = FALSE;
				GFile* _tmp22_;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
				if (!_tmp0_) {
#line 596 "DragNDrop.c"
					gint _tmp1_;
					guint _tmp2_;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp1_ = i;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
					i = _tmp1_ + 1;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp2_ = n;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
					n = _tmp2_ + 1;
#line 607 "DragNDrop.c"
				}
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp0_ = FALSE;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp4_ = i;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
				if (((guint) _tmp4_) < g_list_length (file_list)) {
#line 615 "DragNDrop.c"
					guint _tmp5_;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp5_ = n;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp3_ = _tmp5_ < ((guint) 100);
#line 621 "DragNDrop.c"
				} else {
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp3_ = FALSE;
#line 625 "DragNDrop.c"
				}
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
				if (!_tmp3_) {
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
					break;
#line 631 "DragNDrop.c"
				}
#line 170 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp6_ = i;
#line 170 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp7_ = g_list_nth (file_list, (guint) _tmp6_);
#line 170 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp8_ = _tmp7_->data;
#line 170 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp9_ = _g_object_ref0 ((GFile*) _tmp8_);
#line 170 "../src/utils/dragndrop/DragNDrop.vala"
				fi = _tmp9_;
#line 172 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp10_ = fi;
#line 172 "../src/utils/dragndrop/DragNDrop.vala"
				if (g_file_equal (file, _tmp10_)) {
#line 173 "../src/utils/dragndrop/DragNDrop.vala"
					result = 0;
#line 173 "../src/utils/dragndrop/DragNDrop.vala"
					_g_object_unref0 (fi);
#line 173 "../src/utils/dragndrop/DragNDrop.vala"
					_g_object_unref0 (parent_file);
#line 173 "../src/utils/dragndrop/DragNDrop.vala"
					_g_object_unref0 (ofile);
#line 173 "../src/utils/dragndrop/DragNDrop.vala"
					if (suggested_action_return) {
#line 173 "../src/utils/dragndrop/DragNDrop.vala"
						*suggested_action_return = _vala_suggested_action_return;
#line 659 "DragNDrop.c"
					}
#line 173 "../src/utils/dragndrop/DragNDrop.vala"
					return result;
#line 663 "DragNDrop.c"
				}
#line 176 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp11_ = fi;
#line 176 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp12_ = g_file_get_parent (_tmp11_);
#line 176 "../src/utils/dragndrop/DragNDrop.vala"
				_g_object_unref0 (parent_file);
#line 176 "../src/utils/dragndrop/DragNDrop.vala"
				parent_file = _tmp12_;
#line 177 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp13_ = parent_file;
#line 177 "../src/utils/dragndrop/DragNDrop.vala"
				if (_tmp13_ != NULL) {
#line 677 "DragNDrop.c"
					GFile* _tmp14_;
#line 178 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp14_ = parent_file;
#line 178 "../src/utils/dragndrop/DragNDrop.vala"
					if (g_file_equal (file, _tmp14_)) {
#line 683 "DragNDrop.c"
						GFile* _tmp15_;
#line 183 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp15_ = parent_file;
#line 183 "../src/utils/dragndrop/DragNDrop.vala"
						g_object_unref ((GObject*) _tmp15_);
#line 184 "../src/utils/dragndrop/DragNDrop.vala"
						suggested_action = GDK_ACTION_COPY;
#line 185 "../src/utils/dragndrop/DragNDrop.vala"
						actions = (GDK_ACTION_COPY | GDK_ACTION_MOVE) | GDK_ACTION_LINK;
#line 693 "DragNDrop.c"
					} else {
						GFile* _tmp16_;
#line 187 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp16_ = parent_file;
#line 187 "../src/utils/dragndrop/DragNDrop.vala"
						g_object_unref ((GObject*) _tmp16_);
#line 700 "DragNDrop.c"
					}
				}
#line 192 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp17_ = fi;
#line 192 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp18_ = g_file_get_uri_scheme (_tmp17_);
#line 192 "../src/utils/dragndrop/DragNDrop.vala"
				_g_free0 (scheme);
#line 192 "../src/utils/dragndrop/DragNDrop.vala"
				scheme = _tmp18_;
#line 193 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp19_ = scheme;
#line 193 "../src/utils/dragndrop/DragNDrop.vala"
				if (!g_str_has_prefix (_tmp19_, "file")) {
#line 715 "DragNDrop.c"
					GdkDragAction _tmp20_;
#line 195 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp20_ = actions;
#line 195 "../src/utils/dragndrop/DragNDrop.vala"
					actions = _tmp20_ & (~GDK_ACTION_LINK);
#line 721 "DragNDrop.c"
				}
#line 199 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp22_ = fi;
#line 199 "../src/utils/dragndrop/DragNDrop.vala"
				if (desktop_folder_dragn_drop_util_is_trashed (_tmp22_)) {
#line 199 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp21_ = desktop_folder_dragn_drop_util_is_trashed (file);
#line 729 "DragNDrop.c"
				} else {
#line 199 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp21_ = FALSE;
#line 733 "DragNDrop.c"
				}
#line 199 "../src/utils/dragndrop/DragNDrop.vala"
				if (_tmp21_) {
#line 200 "../src/utils/dragndrop/DragNDrop.vala"
					result = 0;
#line 200 "../src/utils/dragndrop/DragNDrop.vala"
					_g_free0 (scheme);
#line 200 "../src/utils/dragndrop/DragNDrop.vala"
					_g_object_unref0 (fi);
#line 200 "../src/utils/dragndrop/DragNDrop.vala"
					_g_object_unref0 (parent_file);
#line 200 "../src/utils/dragndrop/DragNDrop.vala"
					_g_object_unref0 (ofile);
#line 200 "../src/utils/dragndrop/DragNDrop.vala"
					if (suggested_action_return) {
#line 200 "../src/utils/dragndrop/DragNDrop.vala"
						*suggested_action_return = _vala_suggested_action_return;
#line 751 "DragNDrop.c"
					}
#line 200 "../src/utils/dragndrop/DragNDrop.vala"
					return result;
#line 755 "DragNDrop.c"
				}
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
				_g_free0 (scheme);
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
				_g_object_unref0 (fi);
#line 761 "DragNDrop.c"
			}
		}
#line 206 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp24_ = actions;
#line 206 "../src/utils/dragndrop/DragNDrop.vala"
		if ((_tmp24_ & (GDK_ACTION_COPY | GDK_ACTION_MOVE)) != 0) {
#line 768 "DragNDrop.c"
			GdkDragAction _tmp25_;
#line 207 "../src/utils/dragndrop/DragNDrop.vala"
			_tmp25_ = suggested_action;
#line 207 "../src/utils/dragndrop/DragNDrop.vala"
			_tmp23_ = _tmp25_ == GDK_ACTION_COPY;
#line 774 "DragNDrop.c"
		} else {
#line 206 "../src/utils/dragndrop/DragNDrop.vala"
			_tmp23_ = FALSE;
#line 778 "DragNDrop.c"
		}
#line 206 "../src/utils/dragndrop/DragNDrop.vala"
		if (_tmp23_) {
#line 209 "../src/utils/dragndrop/DragNDrop.vala"
			suggested_action = GDK_ACTION_MOVE;
#line 784 "DragNDrop.c"
			{
				gboolean _tmp26_ = FALSE;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
				i = 0;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
				n = (guint) 0;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp26_ = TRUE;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
				while (TRUE) {
#line 795 "DragNDrop.c"
					gboolean _tmp29_ = FALSE;
					gint _tmp30_;
					GFile* fi = NULL;
					gint _tmp32_;
					GList* _tmp33_;
					gconstpointer _tmp34_;
					GFile* _tmp35_;
					GFile* _tmp36_;
					GFile* _tmp37_;
					GFile* _tmp38_;
					GFileInfo* oinfo = NULL;
					gboolean _tmp46_ = FALSE;
					gboolean _tmp47_ = FALSE;
					GFile* _tmp48_;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
					if (!_tmp26_) {
#line 812 "DragNDrop.c"
						gint _tmp27_;
						guint _tmp28_;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp27_ = i;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
						i = _tmp27_ + 1;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp28_ = n;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
						n = _tmp28_ + 1;
#line 823 "DragNDrop.c"
					}
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp26_ = FALSE;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp30_ = i;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
					if (((guint) _tmp30_) < g_list_length (file_list)) {
#line 831 "DragNDrop.c"
						guint _tmp31_;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp31_ = n;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp29_ = _tmp31_ < ((guint) 100);
#line 837 "DragNDrop.c"
					} else {
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp29_ = FALSE;
#line 841 "DragNDrop.c"
					}
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
					if (!_tmp29_) {
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
						break;
#line 847 "DragNDrop.c"
					}
#line 213 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp32_ = i;
#line 213 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp33_ = g_list_nth (file_list, (guint) _tmp32_);
#line 213 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp34_ = _tmp33_->data;
#line 213 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp35_ = _g_object_ref0 ((GFile*) _tmp34_);
#line 213 "../src/utils/dragndrop/DragNDrop.vala"
					fi = _tmp35_;
#line 215 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp36_ = fi;
#line 215 "../src/utils/dragndrop/DragNDrop.vala"
					if (desktop_folder_dragn_drop_util_is_trashed (_tmp36_)) {
#line 216 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (fi);
#line 216 "../src/utils/dragndrop/DragNDrop.vala"
						break;
#line 867 "DragNDrop.c"
					}
#line 219 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp37_ = fi;
#line 219 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp38_ = _g_object_ref0 (_tmp37_);
#line 219 "../src/utils/dragndrop/DragNDrop.vala"
					_g_object_unref0 (ofile);
#line 219 "../src/utils/dragndrop/DragNDrop.vala"
					ofile = _tmp38_;
#line 220 "../src/utils/dragndrop/DragNDrop.vala"
					oinfo = NULL;
#line 879 "DragNDrop.c"
					{
						GFileInfo* _tmp39_ = NULL;
						GFile* _tmp40_;
						GFileInfo* _tmp41_;
						GFileInfo* _tmp42_;
#line 222 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp40_ = ofile;
#line 222 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp41_ = g_file_query_filesystem_info (_tmp40_, "*", NULL, &_inner_error0_);
#line 222 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp39_ = _tmp41_;
#line 222 "../src/utils/dragndrop/DragNDrop.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 893 "DragNDrop.c"
							goto __catch9_g_error;
						}
#line 222 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp42_ = _tmp39_;
#line 222 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp39_ = NULL;
#line 222 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (oinfo);
#line 222 "../src/utils/dragndrop/DragNDrop.vala"
						oinfo = _tmp42_;
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (_tmp39_);
#line 906 "DragNDrop.c"
					}
					goto __finally9;
					__catch9_g_error:
					{
						GError* _error_ = NULL;
						FILE* _tmp43_;
						GError* _tmp44_;
						const gchar* _tmp45_;
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						_error_ = _inner_error0_;
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						_inner_error0_ = NULL;
#line 224 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp43_ = stderr;
#line 224 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp44_ = _error_;
#line 224 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp45_ = _tmp44_->message;
#line 224 "../src/utils/dragndrop/DragNDrop.vala"
						fprintf (_tmp43_, "Error: %s\n", _tmp45_);
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						_g_error_free0 (_error_);
#line 929 "DragNDrop.c"
					}
					__finally9:
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (oinfo);
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (fi);
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (parent_file);
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (ofile);
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						g_clear_error (&_inner_error0_);
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						return 0U;
#line 948 "DragNDrop.c"
					}
#line 230 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp48_ = ofile;
#line 230 "../src/utils/dragndrop/DragNDrop.vala"
					if (_tmp48_ == NULL) {
#line 230 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp47_ = TRUE;
#line 956 "DragNDrop.c"
					} else {
						GFile* _tmp49_;
#line 231 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp49_ = ofile;
#line 231 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp47_ = !desktop_folder_dragn_drop_util_same_filesystem (file, _tmp49_);
#line 963 "DragNDrop.c"
					}
#line 230 "../src/utils/dragndrop/DragNDrop.vala"
					if (_tmp47_) {
#line 230 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp46_ = TRUE;
#line 969 "DragNDrop.c"
					} else {
						GFileInfo* _tmp50_;
#line 232 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp50_ = oinfo;
#line 232 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp46_ = _tmp50_ != NULL;
#line 976 "DragNDrop.c"
					}
#line 230 "../src/utils/dragndrop/DragNDrop.vala"
					if (_tmp46_) {
#line 236 "../src/utils/dragndrop/DragNDrop.vala"
						suggested_action = GDK_ACTION_COPY;
#line 237 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (oinfo);
#line 237 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (fi);
#line 237 "../src/utils/dragndrop/DragNDrop.vala"
						break;
#line 988 "DragNDrop.c"
					}
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
					_g_object_unref0 (oinfo);
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
					_g_object_unref0 (fi);
#line 994 "DragNDrop.c"
				}
			}
		}
	} else {
#line 241 "../src/utils/dragndrop/DragNDrop.vala"
		if (!desktop_folder_dragn_drop_util_is_folder (file)) {
#line 243 "../src/utils/dragndrop/DragNDrop.vala"
			actions = gdk_drag_context_get_actions (context) & (((GDK_ACTION_COPY | GDK_ACTION_MOVE) | GDK_ACTION_LINK) | GDK_ACTION_PRIVATE);
#line 1003 "DragNDrop.c"
		} else {
#line 246 "../src/utils/dragndrop/DragNDrop.vala"
			g_debug ("DragNDrop.vala:246: Not a valid drop target");
#line 247 "../src/utils/dragndrop/DragNDrop.vala"
			result = 0;
#line 247 "../src/utils/dragndrop/DragNDrop.vala"
			_g_object_unref0 (parent_file);
#line 247 "../src/utils/dragndrop/DragNDrop.vala"
			_g_object_unref0 (ofile);
#line 247 "../src/utils/dragndrop/DragNDrop.vala"
			if (suggested_action_return) {
#line 247 "../src/utils/dragndrop/DragNDrop.vala"
				*suggested_action_return = _vala_suggested_action_return;
#line 1017 "DragNDrop.c"
			}
#line 247 "../src/utils/dragndrop/DragNDrop.vala"
			return result;
#line 1021 "DragNDrop.c"
		}
	}
#line 252 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp51_ = g_file_get_uri_scheme (file);
#line 252 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (scheme);
#line 252 "../src/utils/dragndrop/DragNDrop.vala"
	scheme = _tmp51_;
#line 254 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp52_ = scheme;
#line 254 "../src/utils/dragndrop/DragNDrop.vala"
	if (!g_str_has_prefix (_tmp52_, "file")) {
#line 1034 "DragNDrop.c"
		GdkDragAction _tmp53_;
#line 255 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp53_ = actions;
#line 255 "../src/utils/dragndrop/DragNDrop.vala"
		actions = _tmp53_ & (~GDK_ACTION_LINK);
#line 1040 "DragNDrop.c"
	}
#line 258 "../src/utils/dragndrop/DragNDrop.vala"
	if (desktop_folder_dragn_drop_util_is_trashed (file)) {
#line 1044 "DragNDrop.c"
		GdkDragAction _tmp54_;
#line 259 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp54_ = actions;
#line 259 "../src/utils/dragndrop/DragNDrop.vala"
		actions = _tmp54_ & (~(GDK_ACTION_COPY | GDK_ACTION_LINK));
#line 1050 "DragNDrop.c"
	}
#line 261 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp55_ = actions;
#line 261 "../src/utils/dragndrop/DragNDrop.vala"
	if (_tmp55_ == GDK_ACTION_ASK) {
#line 263 "../src/utils/dragndrop/DragNDrop.vala"
		result = 0;
#line 263 "../src/utils/dragndrop/DragNDrop.vala"
		_g_free0 (scheme);
#line 263 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (parent_file);
#line 263 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (ofile);
#line 263 "../src/utils/dragndrop/DragNDrop.vala"
		if (suggested_action_return) {
#line 263 "../src/utils/dragndrop/DragNDrop.vala"
			*suggested_action_return = _vala_suggested_action_return;
#line 1068 "DragNDrop.c"
		}
#line 263 "../src/utils/dragndrop/DragNDrop.vala"
		return result;
#line 1072 "DragNDrop.c"
	}
#line 268 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp56_ = actions;
#line 268 "../src/utils/dragndrop/DragNDrop.vala"
	if (_tmp56_ != 0) {
#line 1078 "DragNDrop.c"
		GdkDragAction _tmp57_;
#line 269 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp57_ = suggested_action;
#line 269 "../src/utils/dragndrop/DragNDrop.vala"
		_vala_suggested_action_return = _tmp57_;
#line 1084 "DragNDrop.c"
	} else {
		GdkDragAction _tmp58_;
#line 270 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp58_ = actions;
#line 270 "../src/utils/dragndrop/DragNDrop.vala"
		if ((_tmp58_ & GDK_ACTION_ASK) != 0) {
#line 271 "../src/utils/dragndrop/DragNDrop.vala"
			_vala_suggested_action_return = GDK_ACTION_ASK;
#line 1093 "DragNDrop.c"
		} else {
			GdkDragAction _tmp59_;
#line 272 "../src/utils/dragndrop/DragNDrop.vala"
			_tmp59_ = actions;
#line 272 "../src/utils/dragndrop/DragNDrop.vala"
			if ((_tmp59_ & GDK_ACTION_COPY) != 0) {
#line 273 "../src/utils/dragndrop/DragNDrop.vala"
				_vala_suggested_action_return = GDK_ACTION_COPY;
#line 1102 "DragNDrop.c"
			} else {
				GdkDragAction _tmp60_;
#line 274 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp60_ = actions;
#line 274 "../src/utils/dragndrop/DragNDrop.vala"
				if ((_tmp60_ & GDK_ACTION_LINK) != 0) {
#line 275 "../src/utils/dragndrop/DragNDrop.vala"
					_vala_suggested_action_return = GDK_ACTION_LINK;
#line 1111 "DragNDrop.c"
				} else {
					GdkDragAction _tmp61_;
#line 276 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp61_ = actions;
#line 276 "../src/utils/dragndrop/DragNDrop.vala"
					if ((_tmp61_ & GDK_ACTION_MOVE) != 0) {
#line 277 "../src/utils/dragndrop/DragNDrop.vala"
						_vala_suggested_action_return = GDK_ACTION_MOVE;
#line 1120 "DragNDrop.c"
					} else {
#line 279 "../src/utils/dragndrop/DragNDrop.vala"
						_vala_suggested_action_return = GDK_ACTION_PRIVATE;
#line 1124 "DragNDrop.c"
					}
				}
			}
		}
	}
#line 282 "../src/utils/dragndrop/DragNDrop.vala"
	result = actions;
#line 282 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (scheme);
#line 282 "../src/utils/dragndrop/DragNDrop.vala"
	_g_object_unref0 (parent_file);
#line 282 "../src/utils/dragndrop/DragNDrop.vala"
	_g_object_unref0 (ofile);
#line 282 "../src/utils/dragndrop/DragNDrop.vala"
	if (suggested_action_return) {
#line 282 "../src/utils/dragndrop/DragNDrop.vala"
		*suggested_action_return = _vala_suggested_action_return;
#line 1142 "DragNDrop.c"
	}
#line 282 "../src/utils/dragndrop/DragNDrop.vala"
	return result;
#line 1146 "DragNDrop.c"
}


/**
         * eel_g_file_list_new_from_string:
         * @string : a string representation of an URI list.
         *
         * Splits an URI list conforming to the text/uri-list
         * mime type defined in RFC 2483 into individual URIs,
         * discarding any comments and whitespace. The resulting
         * list will hold one #GFile for each URI.
         *
         * If @string contains no URIs, this function
         * will return %NULL.
         *
         * Return value: the list of #GFile<!---->s or %NULL.
         **/
static void
_g_object_unref0_ (gpointer var)
{
#line 299 "../src/utils/dragndrop/DragNDrop.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1169 "DragNDrop.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 299 "../src/utils/dragndrop/DragNDrop.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1178 "DragNDrop.c"
}


GList*
desktop_folder_dragn_drop_util_list_new_from_string (const gchar* str)
{
	GList* result = NULL;
	GList* list = NULL;
	gchar** uris = NULL;
	gint uris_length1 = 0;
	gint _uris_size_ = 0;
	gchar** _tmp0_;
	gchar** _tmp1_;
#line 299 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 301 "../src/utils/dragndrop/DragNDrop.vala"
	list = NULL;
#line 303 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp1_ = _tmp0_ = g_uri_list_extract_uris (str);
#line 303 "../src/utils/dragndrop/DragNDrop.vala"
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 303 "../src/utils/dragndrop/DragNDrop.vala"
	uris = _tmp1_;
#line 303 "../src/utils/dragndrop/DragNDrop.vala"
	uris_length1 = _vala_array_length (_tmp0_);
#line 303 "../src/utils/dragndrop/DragNDrop.vala"
	_uris_size_ = uris_length1;
#line 1206 "DragNDrop.c"
	{
		gint n = 0;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
		n = 0;
#line 1211 "DragNDrop.c"
		{
			gboolean _tmp2_ = FALSE;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
			_tmp2_ = TRUE;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
			while (TRUE) {
#line 1218 "DragNDrop.c"
				gboolean _tmp4_ = FALSE;
				gchar** _tmp5_;
				gint _tmp5__length1;
				gchar** _tmp9_;
				gint _tmp9__length1;
				gint _tmp10_;
				const gchar* _tmp11_;
				GFile* _tmp12_;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
				if (!_tmp2_) {
#line 1229 "DragNDrop.c"
					gint _tmp3_;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp3_ = n;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
					n = _tmp3_ + 1;
#line 1235 "DragNDrop.c"
				}
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp2_ = FALSE;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp5_ = uris;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp5__length1 = uris_length1;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
				if (_tmp5_ != NULL) {
#line 1245 "DragNDrop.c"
					gchar** _tmp6_;
					gint _tmp6__length1;
					gint _tmp7_;
					const gchar* _tmp8_;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp6_ = uris;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp6__length1 = uris_length1;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp7_ = n;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp8_ = _tmp6_[_tmp7_];
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp4_ = _tmp8_ != NULL;
#line 1260 "DragNDrop.c"
				} else {
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp4_ = FALSE;
#line 1264 "DragNDrop.c"
				}
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
				if (!_tmp4_) {
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
					break;
#line 1270 "DragNDrop.c"
				}
#line 306 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp9_ = uris;
#line 306 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp9__length1 = uris_length1;
#line 306 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp10_ = n;
#line 306 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp11_ = _tmp9_[_tmp10_];
#line 306 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp12_ = g_file_new_for_uri (_tmp11_);
#line 306 "../src/utils/dragndrop/DragNDrop.vala"
				list = g_list_append (list, _tmp12_);
#line 1284 "DragNDrop.c"
			}
		}
	}
#line 309 "../src/utils/dragndrop/DragNDrop.vala"
	result = list;
#line 309 "../src/utils/dragndrop/DragNDrop.vala"
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 309 "../src/utils/dragndrop/DragNDrop.vala"
	return result;
#line 1294 "DragNDrop.c"
}


static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
	return _data4_;
#line 1305 "DragNDrop.c"
}


static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (_data4_->f);
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
		g_slice_free (Block4Data, _data4_);
#line 1320 "DragNDrop.c"
	}
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1474 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1474 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1474 "glib-2.0.vapi"
	return result;
#line 1341 "DragNDrop.c"
}


static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1513 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	result = self;
#line 1514 "glib-2.0.vapi"
	return result;
#line 1355 "DragNDrop.c"
}


static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
	return _data5_;
#line 1366 "DragNDrop.c"
}


static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (_data5_->cancellable);
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (_data5_->pd);
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (_data5_->final_target);
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
		block4_data_unref (_data5_->_data4_);
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
		_data5_->_data4_ = NULL;
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
		g_slice_free (Block5Data, _data5_);
#line 1389 "DragNDrop.c"
	}
}


static void
___lambda18_ (Block5Data* _data5_,
              GFile* file)
{
	Block4Data* _data4_;
	gchar* message = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	DesktopFolderProgressDialog* _tmp7_;
	const gchar* _tmp8_;
#line 354 "../src/utils/dragndrop/DragNDrop.vala"
	_data4_ = _data5_->_data4_;
#line 354 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_if_fail (file != NULL);
#line 355 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp0_ = g_strdup (DESKTOP_FOLDER_LANG_DRAGNDROP_COPYING);
#line 355 "../src/utils/dragndrop/DragNDrop.vala"
	message = _tmp0_;
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp1_ = message;
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp2_ = g_strconcat (_tmp1_, " ", NULL);
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp3_ = _tmp2_;
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp4_ = g_file_get_path (file);
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp5_ = _tmp4_;
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp6_ = g_strconcat (_tmp3_, _tmp5_, NULL);
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (message);
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	message = _tmp6_;
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (_tmp5_);
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (_tmp3_);
#line 357 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp7_ = _data5_->pd;
#line 357 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp8_ = message;
#line 357 "../src/utils/dragndrop/DragNDrop.vala"
	desktop_folder_progress_dialog_show_action (_tmp7_, _tmp8_);
#line 354 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (message);
#line 1445 "DragNDrop.c"
}


static void
____lambda18__desktop_folder_util_file_operation_action (GFile* file,
                                                         gpointer self)
{
#line 350 "../src/utils/dragndrop/DragNDrop.vala"
	___lambda18_ (self, file);
#line 1455 "DragNDrop.c"
}


static gint
_________lambda17_ (Block5Data* _data5_)
{
	Block4Data* _data4_;
	gint result = 0;
	DesktopFolderProgressDialog* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 348 "../src/utils/dragndrop/DragNDrop.vala"
	_data4_ = _data5_->_data4_;
#line 1468 "DragNDrop.c"
	{
		GFile* _tmp0_;
		GFile* _tmp1_;
		GCancellable* _tmp2_;
#line 350 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp0_ = _data4_->f;
#line 350 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp1_ = _data5_->final_target;
#line 350 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp2_ = _data5_->cancellable;
#line 350 "../src/utils/dragndrop/DragNDrop.vala"
		desktop_folder_util_copy_recursive (_tmp0_, _tmp1_, G_FILE_COPY_NONE, _tmp2_, ____lambda18__desktop_folder_util_file_operation_action, _data5_, &_inner_error0_);
#line 350 "../src/utils/dragndrop/DragNDrop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1483 "DragNDrop.c"
			goto __catch11_g_error;
		}
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* e = NULL;
		GCancellable* _tmp3_;
		FILE* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 349 "../src/utils/dragndrop/DragNDrop.vala"
		e = _inner_error0_;
#line 349 "../src/utils/dragndrop/DragNDrop.vala"
		_inner_error0_ = NULL;
#line 360 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp3_ = _data5_->cancellable;
#line 360 "../src/utils/dragndrop/DragNDrop.vala"
		g_cancellable_cancel (_tmp3_);
#line 361 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp4_ = stderr;
#line 361 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp5_ = e;
#line 361 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp6_ = _tmp5_->message;
#line 361 "../src/utils/dragndrop/DragNDrop.vala"
		fprintf (_tmp4_, "Error: %s\n", _tmp6_);
#line 349 "../src/utils/dragndrop/DragNDrop.vala"
		_g_error_free0 (e);
#line 1513 "DragNDrop.c"
	}
	__finally11:
#line 349 "../src/utils/dragndrop/DragNDrop.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1518 "DragNDrop.c"
		gint _tmp7_ = -1;
#line 349 "../src/utils/dragndrop/DragNDrop.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 349 "../src/utils/dragndrop/DragNDrop.vala"
		g_clear_error (&_inner_error0_);
#line 349 "../src/utils/dragndrop/DragNDrop.vala"
		return _tmp7_;
#line 1526 "DragNDrop.c"
	}
#line 363 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp8_ = _data5_->pd;
#line 363 "../src/utils/dragndrop/DragNDrop.vala"
	desktop_folder_progress_dialog_stop (_tmp8_);
#line 364 "../src/utils/dragndrop/DragNDrop.vala"
	result = 0;
#line 364 "../src/utils/dragndrop/DragNDrop.vala"
	return result;
#line 1536 "DragNDrop.c"
}


static gpointer
__________lambda17__gthread_func (gpointer self)
{
	gpointer result;
	result = (gpointer) ((gintptr) _________lambda17_ (self));
#line 348 "../src/utils/dragndrop/DragNDrop.vala"
	block5_data_unref (self);
#line 348 "../src/utils/dragndrop/DragNDrop.vala"
	return result;
#line 1549 "DragNDrop.c"
}


void
desktop_folder_dragn_drop_util_copy_move (GList* files,
                                          GFile* target_dir,
                                          GdkDragAction action,
                                          GtkWidget* parent_view,
                                          GCallback done_callback,
                                          GtkWidget* done_callback_data)
{
	GError* _inner_error0_ = NULL;
#line 312 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_if_fail (target_dir != NULL);
#line 319 "../src/utils/dragndrop/DragNDrop.vala"
	if (g_file_query_exists (target_dir, NULL)) {
#line 1566 "DragNDrop.c"
		{
			gint i = 0;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
			i = 0;
#line 1571 "DragNDrop.c"
			{
				gboolean _tmp0_ = FALSE;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp0_ = TRUE;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
				while (TRUE) {
#line 1578 "DragNDrop.c"
					Block4Data* _data4_;
					gboolean _tmp2_ = FALSE;
					gint _tmp4_;
					GList* _tmp5_;
					gconstpointer _tmp6_;
					GFile* _tmp7_;
					GFile* _tmp8_;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
					_data4_ = g_slice_new0 (Block4Data);
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
					_data4_->_ref_count_ = 1;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
					if (!_tmp0_) {
#line 1592 "DragNDrop.c"
						gint _tmp1_;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp1_ = i;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
						i = _tmp1_ + 1;
#line 1598 "DragNDrop.c"
					}
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp0_ = FALSE;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
					if (files != NULL) {
#line 1604 "DragNDrop.c"
						gint _tmp3_;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp3_ = i;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp2_ = ((guint) _tmp3_) < g_list_length (files);
#line 1610 "DragNDrop.c"
					} else {
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp2_ = FALSE;
#line 1614 "DragNDrop.c"
					}
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
					if (!_tmp2_) {
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
						block4_data_unref (_data4_);
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
						_data4_ = NULL;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
						break;
#line 1624 "DragNDrop.c"
					}
#line 321 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp4_ = i;
#line 321 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp5_ = g_list_nth (files, (guint) _tmp4_);
#line 321 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp6_ = _tmp5_->data;
#line 321 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp7_ = _g_object_ref0 ((GFile*) _tmp6_);
#line 321 "../src/utils/dragndrop/DragNDrop.vala"
					_data4_->f = _tmp7_;
#line 322 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp8_ = _data4_->f;
#line 322 "../src/utils/dragndrop/DragNDrop.vala"
					if (g_file_query_exists (_tmp8_, NULL)) {
#line 1640 "DragNDrop.c"
						gchar* path = NULL;
						GFile* _tmp9_;
						gchar* _tmp10_;
						gchar* new_name = NULL;
						GFile* _tmp11_;
						gchar* _tmp12_;
						gchar* target_path = NULL;
						gchar* _tmp13_;
						gboolean _tmp14_ = FALSE;
						gboolean _tmp15_ = FALSE;
						gboolean _tmp16_ = FALSE;
						const gchar* _tmp17_;
						GFlagsValue* _tmp21_;
						GFile* _tmp22_;
						GFile* _tmp23_;
						GFile* _tmp24_;
						gchar* _tmp25_;
						gchar* _tmp26_;
						const gchar* _tmp27_;
						const gchar* _tmp28_;
						const gchar* _tmp29_;
						gchar* _tmp30_;
						gchar* _tmp31_;
#line 324 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp9_ = _data4_->f;
#line 324 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp10_ = g_file_get_path (_tmp9_);
#line 324 "../src/utils/dragndrop/DragNDrop.vala"
						path = _tmp10_;
#line 325 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp11_ = _data4_->f;
#line 325 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp12_ = g_file_get_basename (_tmp11_);
#line 325 "../src/utils/dragndrop/DragNDrop.vala"
						new_name = _tmp12_;
#line 326 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp13_ = g_file_get_path (target_dir);
#line 326 "../src/utils/dragndrop/DragNDrop.vala"
						target_path = _tmp13_;
#line 329 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp17_ = path;
#line 329 "../src/utils/dragndrop/DragNDrop.vala"
						if (g_str_has_prefix (_tmp17_, "/usr/local/share/applications/")) {
#line 329 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp16_ = TRUE;
#line 1686 "DragNDrop.c"
						} else {
							const gchar* _tmp18_;
#line 330 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp18_ = path;
#line 330 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp16_ = g_str_has_prefix (_tmp18_, "/usr/share/");
#line 1693 "DragNDrop.c"
						}
#line 329 "../src/utils/dragndrop/DragNDrop.vala"
						if (_tmp16_) {
#line 329 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp15_ = TRUE;
#line 1699 "DragNDrop.c"
						} else {
							const gchar* _tmp19_;
#line 331 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp19_ = path;
#line 331 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp15_ = string_contains (_tmp19_, "/.local/share/applications/");
#line 1706 "DragNDrop.c"
						}
#line 329 "../src/utils/dragndrop/DragNDrop.vala"
						if (_tmp15_) {
#line 1710 "DragNDrop.c"
							const gchar* _tmp20_;
#line 332 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp20_ = path;
#line 332 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp14_ = g_str_has_suffix (_tmp20_, ".desktop");
#line 1716 "DragNDrop.c"
						} else {
#line 329 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp14_ = FALSE;
#line 1720 "DragNDrop.c"
						}
#line 329 "../src/utils/dragndrop/DragNDrop.vala"
						if (_tmp14_) {
#line 334 "../src/utils/dragndrop/DragNDrop.vala"
							if (action == GDK_ACTION_MOVE) {
#line 335 "../src/utils/dragndrop/DragNDrop.vala"
								action = GDK_ACTION_COPY;
#line 1728 "DragNDrop.c"
							}
						}
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp21_ = g_flags_get_first_value (g_type_class_ref (gdk_drag_action_get_type ()), action);
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp22_ = _data4_->f;
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp23_ = g_file_get_parent (_tmp22_);
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp24_ = _tmp23_;
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp25_ = g_file_get_path (_tmp24_);
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp26_ = _tmp25_;
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp27_ = string_to_string (_tmp26_);
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp28_ = target_path;
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp29_ = string_to_string (_tmp28_);
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp30_ = g_strconcat ((_tmp21_ != NULL) ? _tmp21_->value_name : NULL, ", ", _tmp27_, " -> ", _tmp29_, NULL);
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp31_ = _tmp30_;
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						g_debug ("DragNDrop.vala:339: %s", _tmp31_);
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_g_free0 (_tmp31_);
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_g_free0 (_tmp26_);
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (_tmp24_);
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
						if (action == GDK_ACTION_COPY) {
#line 1763 "DragNDrop.c"
							Block5Data* _data5_;
							const gchar* _tmp32_;
							gchar* _tmp33_;
							gchar* _tmp34_;
							GFile* _tmp35_;
							gchar* _tmp36_;
							gchar* _tmp37_;
							gchar* _tmp38_;
							gchar* _tmp39_;
							GFile* _tmp40_;
							GFile* _tmp41_;
							DesktopFolderProgressDialog* _tmp42_;
							DesktopFolderProgressDialog* _tmp43_;
							GCancellable* _tmp44_;
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
							_data5_ = g_slice_new0 (Block5Data);
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
							_data5_->_ref_count_ = 1;
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
							_data5_->_data4_ = block4_data_ref (_data4_);
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp32_ = target_path;
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp33_ = g_strconcat (_tmp32_, "/", NULL);
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp34_ = _tmp33_;
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp35_ = _data4_->f;
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp36_ = g_file_get_basename (_tmp35_);
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp37_ = _tmp36_;
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp38_ = g_strconcat (_tmp34_, _tmp37_, NULL);
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp39_ = _tmp38_;
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp40_ = g_file_new_for_path (_tmp39_);
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp41_ = _tmp40_;
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_g_free0 (_tmp39_);
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_g_free0 (_tmp37_);
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_g_free0 (_tmp34_);
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_data5_->final_target = _tmp41_;
#line 344 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp42_ = desktop_folder_progress_dialog_new (DESKTOP_FOLDER_LANG_DRAGNDROP_FILE_OPERATIONS, G_TYPE_CHECK_INSTANCE_CAST (parent_view, gtk_window_get_type (), GtkWindow));
#line 344 "../src/utils/dragndrop/DragNDrop.vala"
							g_object_ref_sink (_tmp42_);
#line 344 "../src/utils/dragndrop/DragNDrop.vala"
							_data5_->pd = _tmp42_;
#line 345 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp43_ = _data5_->pd;
#line 345 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp44_ = desktop_folder_progress_dialog_start (_tmp43_);
#line 345 "../src/utils/dragndrop/DragNDrop.vala"
							_data5_->cancellable = _tmp44_;
#line 1824 "DragNDrop.c"
							{
								GThread* _tmp45_;
								GThread* _tmp46_;
#line 348 "../src/utils/dragndrop/DragNDrop.vala"
								_tmp45_ = g_thread_try_new ("DesktopFolder File Operation", __________lambda17__gthread_func, block5_data_ref (_data5_), &_inner_error0_);
#line 348 "../src/utils/dragndrop/DragNDrop.vala"
								_tmp46_ = _tmp45_;
#line 348 "../src/utils/dragndrop/DragNDrop.vala"
								_g_thread_unref0 (_tmp46_);
#line 348 "../src/utils/dragndrop/DragNDrop.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1836 "DragNDrop.c"
									goto __catch10_g_error;
								}
#line 367 "../src/utils/dragndrop/DragNDrop.vala"
								if (done_callback != NULL) {
#line 368 "../src/utils/dragndrop/DragNDrop.vala"
									done_callback ();
#line 1843 "DragNDrop.c"
								}
							}
							goto __finally10;
							__catch10_g_error:
							{
								GError* _error_ = NULL;
								GCancellable* _tmp47_;
								DesktopFolderProgressDialog* _tmp48_;
								FILE* _tmp49_;
								GError* _tmp50_;
								const gchar* _tmp51_;
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								_error_ = _inner_error0_;
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								_inner_error0_ = NULL;
#line 371 "../src/utils/dragndrop/DragNDrop.vala"
								_tmp47_ = _data5_->cancellable;
#line 371 "../src/utils/dragndrop/DragNDrop.vala"
								g_cancellable_cancel (_tmp47_);
#line 372 "../src/utils/dragndrop/DragNDrop.vala"
								_tmp48_ = _data5_->pd;
#line 372 "../src/utils/dragndrop/DragNDrop.vala"
								desktop_folder_progress_dialog_stop (_tmp48_);
#line 373 "../src/utils/dragndrop/DragNDrop.vala"
								_tmp49_ = stderr;
#line 373 "../src/utils/dragndrop/DragNDrop.vala"
								_tmp50_ = _error_;
#line 373 "../src/utils/dragndrop/DragNDrop.vala"
								_tmp51_ = _tmp50_->message;
#line 373 "../src/utils/dragndrop/DragNDrop.vala"
								fprintf (_tmp49_, "Error: %s\n", _tmp51_);
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								_g_error_free0 (_error_);
#line 1877 "DragNDrop.c"
							}
							__finally10:
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								block5_data_unref (_data5_);
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								_data5_ = NULL;
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								_g_free0 (target_path);
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								_g_free0 (new_name);
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								_g_free0 (path);
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								block4_data_unref (_data4_);
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								_data4_ = NULL;
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								g_clear_error (&_inner_error0_);
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								return;
#line 1902 "DragNDrop.c"
							}
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
							block5_data_unref (_data5_);
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
							_data5_ = NULL;
#line 1908 "DragNDrop.c"
						} else {
#line 375 "../src/utils/dragndrop/DragNDrop.vala"
							if (action == GDK_ACTION_MOVE) {
#line 1912 "DragNDrop.c"
								{
									GFile* final_target = NULL;
									const gchar* _tmp52_;
									gchar* _tmp53_;
									gchar* _tmp54_;
									GFile* _tmp55_;
									gchar* _tmp56_;
									gchar* _tmp57_;
									gchar* _tmp58_;
									gchar* _tmp59_;
									GFile* _tmp60_;
									GFile* _tmp61_;
									GFile* _tmp62_;
									GFile* _tmp63_;
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp52_ = target_path;
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp53_ = g_strconcat (_tmp52_, "/", NULL);
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp54_ = _tmp53_;
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp55_ = _data4_->f;
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp56_ = g_file_get_basename (_tmp55_);
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp57_ = _tmp56_;
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp58_ = g_strconcat (_tmp54_, _tmp57_, NULL);
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp59_ = _tmp58_;
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp60_ = g_file_new_for_path (_tmp59_);
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp61_ = _tmp60_;
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_g_free0 (_tmp59_);
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_g_free0 (_tmp57_);
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_g_free0 (_tmp54_);
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									final_target = _tmp61_;
#line 378 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp62_ = _data4_->f;
#line 378 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp63_ = final_target;
#line 378 "../src/utils/dragndrop/DragNDrop.vala"
									g_file_move (_tmp62_, _tmp63_, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error0_);
#line 378 "../src/utils/dragndrop/DragNDrop.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 378 "../src/utils/dragndrop/DragNDrop.vala"
										_g_object_unref0 (final_target);
#line 1965 "DragNDrop.c"
										goto __catch12_g_error;
									}
#line 379 "../src/utils/dragndrop/DragNDrop.vala"
									if (done_callback != NULL) {
#line 380 "../src/utils/dragndrop/DragNDrop.vala"
										done_callback ();
#line 1972 "DragNDrop.c"
									}
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									_g_object_unref0 (final_target);
#line 1976 "DragNDrop.c"
								}
								goto __finally12;
								__catch12_g_error:
								{
									GError* _error_ = NULL;
									FILE* _tmp64_;
									GError* _tmp65_;
									const gchar* _tmp66_;
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									_error_ = _inner_error0_;
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									_inner_error0_ = NULL;
#line 382 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp64_ = stderr;
#line 382 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp65_ = _error_;
#line 382 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp66_ = _tmp65_->message;
#line 382 "../src/utils/dragndrop/DragNDrop.vala"
									fprintf (_tmp64_, "Error: %s\n", _tmp66_);
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									_g_error_free0 (_error_);
#line 1999 "DragNDrop.c"
								}
								__finally12:
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									_g_free0 (target_path);
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									_g_free0 (new_name);
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									_g_free0 (path);
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									block4_data_unref (_data4_);
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									_data4_ = NULL;
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									g_clear_error (&_inner_error0_);
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									return;
#line 2020 "DragNDrop.c"
								}
							} else {
#line 384 "../src/utils/dragndrop/DragNDrop.vala"
								if (action == GDK_ACTION_LINK) {
#line 2025 "DragNDrop.c"
									{
										GFile* target_file = NULL;
										const gchar* _tmp67_;
										const gchar* _tmp68_;
										const gchar* _tmp69_;
										const gchar* _tmp70_;
										gchar* _tmp71_;
										gchar* _tmp72_;
										GFile* _tmp73_;
										GFile* _tmp74_;
										GFile* _tmp75_;
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp67_ = target_path;
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp68_ = string_to_string (_tmp67_);
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp69_ = new_name;
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp70_ = string_to_string (_tmp69_);
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp71_ = g_strconcat (_tmp68_, "/", _tmp70_, NULL);
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp72_ = _tmp71_;
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp73_ = g_file_new_for_path (_tmp72_);
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp74_ = _tmp73_;
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										_g_free0 (_tmp72_);
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										target_file = _tmp74_;
#line 387 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp75_ = target_file;
#line 387 "../src/utils/dragndrop/DragNDrop.vala"
										if (!g_file_query_exists (_tmp75_, NULL)) {
#line 2061 "DragNDrop.c"
											gchar* command = NULL;
											GFile* _tmp76_;
											gchar* _tmp77_;
											gchar* _tmp78_;
											const gchar* _tmp79_;
											const gchar* _tmp80_;
											const gchar* _tmp81_;
											const gchar* _tmp82_;
											const gchar* _tmp83_;
											gchar* _tmp84_;
											gchar* _tmp85_;
											GAppInfo* appinfo = NULL;
											const gchar* _tmp86_;
											GAppInfo* _tmp87_;
											GAppInfo* _tmp88_;
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp76_ = _data4_->f;
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp77_ = g_file_get_path (_tmp76_);
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp78_ = _tmp77_;
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp79_ = string_to_string (_tmp78_);
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp80_ = target_path;
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp81_ = string_to_string (_tmp80_);
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp82_ = new_name;
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp83_ = string_to_string (_tmp82_);
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp84_ = g_strconcat ("ln -s \"", _tmp79_, "\" \"", _tmp81_, "/", _tmp83_, "\"", NULL);
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp85_ = _tmp84_;
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_g_free0 (_tmp78_);
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											command = _tmp85_;
#line 389 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp86_ = command;
#line 389 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp87_ = g_app_info_create_from_commandline (_tmp86_, NULL, G_APP_INFO_CREATE_SUPPORTS_URIS, &_inner_error0_);
#line 389 "../src/utils/dragndrop/DragNDrop.vala"
											appinfo = _tmp87_;
#line 389 "../src/utils/dragndrop/DragNDrop.vala"
											if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 389 "../src/utils/dragndrop/DragNDrop.vala"
												_g_free0 (command);
#line 389 "../src/utils/dragndrop/DragNDrop.vala"
												_g_object_unref0 (target_file);
#line 2113 "DragNDrop.c"
												goto __catch13_g_error;
											}
#line 390 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp88_ = appinfo;
#line 390 "../src/utils/dragndrop/DragNDrop.vala"
											g_app_info_launch_uris (_tmp88_, NULL, NULL, &_inner_error0_);
#line 390 "../src/utils/dragndrop/DragNDrop.vala"
											if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 390 "../src/utils/dragndrop/DragNDrop.vala"
												_g_object_unref0 (appinfo);
#line 390 "../src/utils/dragndrop/DragNDrop.vala"
												_g_free0 (command);
#line 390 "../src/utils/dragndrop/DragNDrop.vala"
												_g_object_unref0 (target_file);
#line 2128 "DragNDrop.c"
												goto __catch13_g_error;
											}
#line 387 "../src/utils/dragndrop/DragNDrop.vala"
											_g_object_unref0 (appinfo);
#line 387 "../src/utils/dragndrop/DragNDrop.vala"
											_g_free0 (command);
#line 2135 "DragNDrop.c"
										}
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										_g_object_unref0 (target_file);
#line 2139 "DragNDrop.c"
									}
									goto __finally13;
									__catch13_g_error:
									{
										GError* _error_ = NULL;
										FILE* _tmp89_;
										GError* _tmp90_;
										const gchar* _tmp91_;
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										_error_ = _inner_error0_;
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										_inner_error0_ = NULL;
#line 393 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp89_ = stderr;
#line 393 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp90_ = _error_;
#line 393 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp91_ = _tmp90_->message;
#line 393 "../src/utils/dragndrop/DragNDrop.vala"
										fprintf (_tmp89_, "Error: %s\n", _tmp91_);
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										_g_error_free0 (_error_);
#line 2162 "DragNDrop.c"
									}
									__finally13:
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										_g_free0 (target_path);
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										_g_free0 (new_name);
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										_g_free0 (path);
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										block4_data_unref (_data4_);
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										_data4_ = NULL;
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										g_clear_error (&_inner_error0_);
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										return;
#line 2183 "DragNDrop.c"
									}
								} else {
#line 396 "../src/utils/dragndrop/DragNDrop.vala"
									g_debug ("DragNDrop.vala:396: unknown action!");
#line 2188 "DragNDrop.c"
								}
							}
						}
#line 322 "../src/utils/dragndrop/DragNDrop.vala"
						_g_free0 (target_path);
#line 322 "../src/utils/dragndrop/DragNDrop.vala"
						_g_free0 (new_name);
#line 322 "../src/utils/dragndrop/DragNDrop.vala"
						_g_free0 (path);
#line 2198 "DragNDrop.c"
					}
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
					block4_data_unref (_data4_);
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
					_data4_ = NULL;
#line 2204 "DragNDrop.c"
				}
			}
		}
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



